//RenMerge0307
// XXX REINTRODUCE ASAP "use strict";
//template to hold overall study with all display info
var study;

//template to keep track of which questions are answered in a section
var changedQuestions;

//template to keep track of all the current users
var ramsUsers = new HashSet();

//template to keep track of members of the study team
var studyMembers = new HashSet();

var sqlUsers = [];

//template to hold all responses from a user
var rollup;

//
var deletedHIPAA;

var attachments;

//template to keep track of how many stages the study has been through
var targetStage;

//template to keep track of if the study is in draft or in review
var targetState;

//template to hold responses from previous application stages
var previousStageResponses = [];

//template for the study title
var studyTitle = "";

var requestDigest = null;

//study title's id
var studyTitleID = "0";

//template for the study ID
var assignedID = "1";

var parentID;

//template for map between parent/child questions
var dependency = new Hashtable();

//Set of all answers IDs that are in the rollup
var rollupAnswers = new HashSet();

var rollupQuestions = new HashSet();

//Set of all answers and questions IDs that are in a previous application stage's rollup
var previousStageAnswers = new Hashtable();

var previousStageQuestions = new Hashtable();

var userIDMap = new Hashtable();

var childrenStudies = new Hashtable();

var previousStage = [];

var validSection = [];

var currentStudyStatus;

//Linking in the web service
var restPath = RAMS.Environment.WebService.URL;
//Linking in the sharepoint site
var siteUrl = RAMS.Environment.SharePoint.URL;

var subCommittee;

//template for the user.
var currentUser;

var currentFacility = null;

var spAppData = null;

var spsubsiteAppData = null;

var currentFormVersion;

var currentFormType;

var readOnlyState = true;

//Inital function called by HTML. Sets up baseline information needed.
function process(behavior) {
    //Grabs username and study ID
    getContext(function() {
		sendREST("POST", siteUrl + "_api/ContextInfo", null, function(json) {
			requestDigest = json.d.GetContextWebInformation.FormDigestValue;
			continueProcess(behavior);
		});
	});
};

function continueProcess(behavior) {
    if (assignedID === "1") { // Not yet created.
        targetStage = 1;
        targetState = 1; 
        readOnlyState = false;
		currentFormType = "Parent";
		currentFormVersion = RAMS.Environment.WebService.Form[currentFormType]; // XXX gross
		sendREST("GET", restPath + "forms/" + currentFormVersion, null, function(json) { // most recent forms
			study = json;
			//This section will intercept the study object and delete HIPAA from the form collection
			for (var x = 0; x < study.containedFormCollection.length;x++) {
				var formTitle = study.containedFormCollection[x].containedForm.title;
				if (formTitle.indexOf("HIPAA") !== -1) {
                    deletedHIPAA = study.containedFormCollection[x].containedForm.formsID;
					study.containedFormCollection.splice(x, 1);
				}
			}
			sectionBuilder(0);
		});
		return;
	}

	//Getting the most recent stage and state to use later
	sendREST("GET", siteUrl + "_api/Web/Lists/GetByTitle('Application')/Items" +
							  "?$filter=Study_ID eq '" + assignedID + "' or ParentStudyID eq '" + assignedID + "'", null, function(json) {
		sendREST("GET", restPath + "study/" + assignedID, null, function(studyResponse) {
			if (targetStage === undefined)
				targetStage = studyResponse.studyStatusCollection.length;
			targetState = studyResponse.studyStatusCollection[targetStage - 1].studyState.studyStatesID;
			currentFormVersion = studyResponse.formVersionsID;
			currentStudyStatus = studyResponse.studyStatusCollection;
			studyTitle = studyResponse.title;

			sendREST("GET", restPath + "forms", null, function(currentForms) {
				determineFormType(currentForms);
			    
				for(var i=0; i<studyResponse.studyMembersCollection.length; i++){
					if(studyResponse.studyMembersCollection[i].activeMember)
						if (studyResponse.studyMembersCollection[i].user.SPUser ){
							studyMembers.add(studyResponse.studyMembersCollection[i].user.SPUser);
						}		
				}

				//moving below study members for leverage
				sendREST("GET", restPath + "forms/" + currentFormVersion, null, function(currentForms) {
					study = currentForms;
					grabAppData(json, function() {
						//alert('Done with grabAppData...checking for behavior');
						switch (behavior) {
						case "edit":
						    //alert('grabbing Child Studies');
							grabChildStudies(json);
							if (targetState == 1)
								readOnlyState = false;
							else
								//alert('doing select Toolbar');
								selectToolbar(targetState);

							if (targetStage > 1)
								//alert('Getting previous stage responses');
								getPreviousStageResponses();
								//alert('Invoking Section Builder');
								sectionBuilder(0);
							break;
						case "print":
							// The printable view of all sections/responses keeps the readOnlyState set to true.
							printableSectionsBuilder();
							break;
						default:
							alert("Unknown processing behavior: " + behavior);
						}
					});
				});
			});
		});
	});
}
//This function will grab the children studies of the main study.
function grabChildStudies(json){
    var i, studies = json.d.results;
    for (i = 0; i < studies.length; i++)
        if (studies[i].ParentStudyID == assignedID && studies[i].Study_ID != null)//this indicates that this is a the child study
            childrenStudies.put(studies[i][RAMS.Environment.SharePoint.List.Application.FacilityLookupId], studies[i]);
	if(json.d.__next){
		sendREST("GET", json.d.__next, null, function(returnedJson){
			grabChildStudies(returnedJson);
		});
	}
}

// Looking only for Study_ID match, not ParentStudyID, here.
function grabAppData(json, callback){
    //console.log("looking for appdata");
    for(var i=0; i<json.d.results.length; i++){
        if(json.d.results[i].Study_ID == assignedID){
            var andThen = function(returnedUrl) {
                subCommittee = returnedUrl;
                sendREST("GET", siteUrl + subCommittee + "_api/Web/Lists/GetByTitle('Committee Topics')/Items" +
                                "?$filter=Study_ID eq '" + assignedID + "'", null, function(subsiteJson) {
                    grabspsubsiteAppData(subsiteJson, function(){
                        callback();
                    });
                });
            };
            spAppData = json.d.results[i];

            /*ONLY entering this area if we need to search for the subsite.*/
            //need to look for the sub-sites url the hard way
            if((targetStage == 1) && (spAppData.ParentStudyID == null)){
                if((spAppData.ApplicationStatus != null) && (spAppData.ApplicationSiteType == "Central")){
                    //console.log("looking for a central substring?");
                    getCentralUrl(andThen);
                }else if((spAppData.ApplicationStatus != "Draft") && (spAppData.ApplicationStatus != null)){
                    //console.log("looking for a regular substring?");
                    getSites(andThen);
                }else{
                    //we don't need to find the subsite url, but we do 
                    //need to signify we're done.
                    callback();
                }                
            }else{
                /*the application has already been submitted.*/
                getCommitteeSubString(spAppData[RAMS.Environment.SharePoint.List.Application.FacilityLookupId], andThen);
            }
        }
    }
    if(spAppData == null){
        if(json.d.__next){
            sendREST("GET", json.d.__next, null, function(returnedJson){
                grabAppData(returnedJson, callback);
            });
        }else{
            //console.log("there is no next");
        }
    }else{
        /*SHOULD NEVER GET HERE, but just in case.*/
        //console.log("got to the end, spappdata is: " + JSON.stringify(spAppData));
        //callback();
    }
}

function grabspsubsiteAppData(subsiteJson, callback){
    ////console.log("looking for subsite app data");
    for(var i=0; i<subsiteJson.d.results.length; i++){
        if(subsiteJson.d.results[i].Study_ID == assignedID){
            spsubsiteAppData = subsiteJson.d.results[i];
            callback();
            break;
        }
    }
    if (spsubsiteAppData == null) {
	if (subsiteJson.d.__next) {
	    sendREST("GET", subsiteJson.d.__next, null, function(returnedJson) {
	        grabspsubsiteAppData(returnedJson, callback);
	    });
        } else {
	    alert("Application not found in Committee Topics.");
	}
    } 
}

//Getting user's responses from the database and updating the local version of
//the user's responses, called rollupAnswers
function sectionBuilder(targetSection){
    rollupAnswers = new HashSet();
    rollupQuestions = new HashSet();

    //all user's responses that are in the database
    if(assignedID!="1"){
        //When the assignedID is set to 1, we know that there is no data in the database for a study
        sendREST("GET", restPath.concat("study/"+assignedID+"/responses/"+targetStage+"/rollup"), null, function(json){
            rollup = json;
           
            for(var j=0; j<rollup.responses.length; j++){
                //adding selected radios and checkboxes
                if(rollup.responses[j].answersID !== undefined){
                    rollupAnswers.add(rollup.responses[j].answersID);
                }
                //adding questions regardless
                rollupQuestions.add(rollup.responses[j].questionsID);
            }
        
            continueSectionBuilder(targetSection);
        });
    }else{
        //setting an empty rollup
        rollup = {};
        continueSectionBuilder(targetSection);
    }
};

function determineFormType(currentForms){
/* XXX this is awful and only "works" for the most recent uploaded forms (that we hardcoded into rams-environment.js) */
    currentFormType = RAMS.Environment.WebService.Form[currentFormVersion];
};

function getContext(andThen) {
    var splitURL, tempUsers, splitUsername;

    //finding the user information in the database 
    sendREST("GET", siteUrl.concat("_api/web/SiteUsers"), null, function(json){
        sendREST("GET", siteUrl.concat("_api/Web/CurrentUser"), null, function(currentUserJson){ 
            sendREST("POST", restPath.concat("user"), null, function(sqlUserJson){  
                splitURL = window.location.href.split("?");

                //study id that was passed
                assignedID = splitURL[1];

                //stage number that was passed
                targetStage = splitURL[2];

                ramsUsers = buildUsers(json, null);
                tempUsers = ramsUsers.values();
                sqlUsers = sqlUserJson;

                currentUser = currentUserJson.d;

                var tempUsers = json.d.results;
                for(var i=0; i<tempUsers.length; i++){
                    for(var j=0; j<sqlUserJson.length; j++){
                        if(tempUsers[i].Title == sqlUserJson[j].displayName){
                            ////console.log("for " + tempUsers[i].Title + ", converting " + sqlUserJson[j].SPUser + " to " + tempUsers[i].Id);
                            userIDMap.put(sqlUserJson[j].SPUser, tempUsers[i].Id);
                        }
                    }
                }
				andThen();
            });
        });
    });
};

function buildUsers(json, tempUsers){
    if(tempUsers == null){
        var tempUsers = new HashSet();
    }    

    for(var i=0; i<json.d.results.length; i++){
        tempUsers.add({
            "__metadata": json.d.results[i].__metadata,
            "Id": json.d.results[i].Id,
            "IsHiddenInUI": json.d.results[i].IsHiddenInUI,
            "LoginName": json.d.results[i].LoginName,
            "Title": json.d.results[i].Title,
            "PrincipalType": json.d.results[i].PrincipalType,
            "Email": json.d.results[i].Email,
            "IsSiteAdmin": "false", 
            "UserID": json.d.results[i].UserID
        });
    }
    if(json.d.__next){
        sendREST("GET", json.d.__next, null, function(returnedJson){
            buildUsers(returnedJson, tempUsers);
        });
    }else{
        return tempUsers;
    }   
}

//looking for subsite url
function getSites(callback){
    var currentGroups;
    var groupId; 
    var currentCommittee;
    var subUrl = "";
    var sliceAt;
    var removeString;

    sendREST("GET", siteUrl.concat("_api/Web/CurrentUser/Groups"), null, function(groupJson){
        currentGroups = groupJson.d.results;
        //looking for group that has "members" in the name since that signifies the
        //site a user should push their applications to
        var siteFound = false;
        for(var i=0; i<currentGroups.length; i++){
            //console.log("A group is: " + currentGroups[i].Title);
            if(currentGroups[i].Title.indexOf("Users") > -1){
                //console.log("Found my home group: " + currentGroups[i].Title + " with the id " + currentGroups[i].Id);
                siteFound = true;
                groupId = currentGroups[i].Id;
                //comparing the member group against the committee list to look for a match
                sendREST("GET", siteUrl.concat("_api/Web/lists/getbytitle('Committee List')/items"), null, function(committeeJson){
                    currentCommittee = committeeJson.d.results;
                    for(var j=0; j<currentCommittee.length; j++){
                        //console.log("checking " + groupId + " vs " + currentCommittee[j].UsersId);
                        if(groupId == currentCommittee[j].UsersId){
                            subUrl = currentCommittee[j].CommitteeSub_x002d_Site.Url;
                            subUrl = subUrl.replace(siteUrl, "");
                            subUrl = subUrl + "/";
                            // sliceAt = subUrl.indexOf("/") + 1;
                            // removeString = subUrl.slice(sliceAt, subUrl.length);
                            // subUrl = subUrl.replace(removeString, "");
                            //console.log("the ID is: " + currentCommittee[j].Id);
                            getFacility(currentCommittee[j].Id, function(returnedFacilityId, returnedLiaisonId){
                                //console.log("the current facility is: " + returnedFacilityId + " with " + returnedLiaisonId);
                                callback(subUrl, returnedFacilityId, returnedLiaisonId);
                            })

                            //callback(subUrl);
                            // subCommittee = subUrl;
                            //localSiteLiasonId = currentCommittee[j].Local_x0020_Site_x0020_LiaisonsId;
                            //continueProcess();
                        }
                    }
                });
            }      
        }
        if(siteFound == false){
            alert('Submit Error: Please contact your Local Site Liaison to align you to an active IRB Site.');
        }
    });
};

function getCentralUrl(callback){
    var subUrl = "";
    var siteFound = false;
    //console.log("looking for central IRB URL");
    sendREST("GET", siteUrl.concat("_api/Web/lists/getbytitle('Committee List')/items"), null, function(committeeJson){
        currentCommittee = committeeJson.d.results;
        for(var i=0; i<currentCommittee.length; i++){
            if (currentCommittee[i].Title === RAMS.Environment.SharePoint.CentralIRBSite) {
                siteFound = true;
                subUrl = currentCommittee[i].CommitteeSub_x002d_Site.Url;
                ////console.log("found the central committee: " + currentCommittee[i].Title + " with " + currentCommittee[i].CommitteeSub_x002d_Site.Url);
                subUrl = subUrl.replace(siteUrl, "");
                subUrl = subUrl + "/";
                // sliceAt = subUrl.indexOf("/") + 1;
                // subUrl = subUrl.slice(0, sliceAt);
                //console.log("the ID is: " + currentCommittee[i].Id);
                getFacility(currentCommittee[i].Id, function(returnedFacilityId, returnedLiaisonId){
                    callback(subUrl, returnedFacilityId, returnedLiaisonId);
                });
                break;
            }
        }
        if(siteFound == false){
            //alert('Please contact your Local Site Liaison to have them align you to an active IRB Site.');
        }
    });
};

function getFacility(committeeID, callback){
    sendREST("GET", siteUrl.concat("_api/web/lists/getbytitle('Facility')/items"), null, function(facilityJson){
        currentFacilities = facilityJson.d.results;
        for(var i=0; i<currentFacilities.length; i++){
            if(currentFacilities[i].CommitteeLookupId == committeeID){
                callback(currentFacilities[i].Id, currentFacilities[i].FacilityLiaisonId);
            }
        }
    });
}
//FacilityLookupId
function getCommitteeSubString(facilityLookup, callback){
    var subUrl, sliceAt;
    //grab all facilities, find yours, find the committee lookup
    sendREST("GET", siteUrl.concat("_api/web/lists/getbytitle('Facility')/items("+facilityLookup+")"), null, function(returnedFacility){
        //console.log("our facility is " + returnedFacility.d.FacilityName + " with committee lookup " + returnedFacility.d.CommitteeLookupId);
        sendREST("GET", siteUrl.concat("_api/web/lists/getbytitle('Committee List')/items("+returnedFacility.d.CommitteeLookupId+")"), null, function(returnedCommittee){
            //console.log("our committee is: " + returnedCommittee.d.Title + " with substring " + returnedCommittee.d.CommitteeSub_x002d_Site.Url);
            subUrl = (returnedCommittee.d.CommitteeSub_x002d_Site.Url).replace(siteUrl, "");
            subUrl = subUrl + "/";
            // sliceAt = subUrl.indexOf("/") + 1;
            // subUrl = subUrl.slice(0, sliceAt);
            //console.log("the subsite is: " + subUrl);
            callback(subUrl);
        });
    });
};

function getPreviousStageResponses(){
    for(var i=1; i<targetStage; i++){
        sendREST("GET", restPath.concat("study/"+assignedID+"/responses/"+i), null, function(stageResponseValidator){
            for(var j=0; j<stageResponseValidator.length; j++){
                if(stageResponseValidator[j].answersID !== undefined){
                    previousStageAnswers.put(stageResponseValidator[j].answersID, stageResponseValidator[j]);
                }else{
                    previousStageQuestions.put(stageResponseValidator[j].questionsID, stageResponseValidator[j]);
                }
            }
        });
    }
}

//sets up the structure of the question/sidebar section and 
//attaches to the proper area in webpage.
function continueSectionBuilder(targetSection){
	window.scrollTo(0,0); //before reloading page with new section, scroll to the top of the page
	//rollupAnswers = new HashSet();

    //removing any trace of the last section that was built
    $('#refresh-section').remove();
    var section, row, column, sideColumn;
    
    //setting up the initial structure of page
    row = document.createElement("div");
    row.setAttribute("class", "row");
    row.setAttribute("id", "refresh-section");
    $('div#insert').append(row);

    column = document.createElement("div");
    column.setAttribute("class", "col-xs-9");
    row.appendChild(column);

    columnBuilder(targetSection);

    sideColumn = document.createElement("div");
    sideColumn.setAttribute("class", "col-xs-3 toolbar");
    row.appendChild(sideColumn);

    sideColumnBuilder(targetSection);

    if(currentFormVersion == 54){
    	//Grab the title of the principal 
        sendREST("GET", siteUrl + "_api/Web/GetUserById(" + spAppData.ParticipatingSiteInvestigatorId + ")/", null, function(data) {
        	var title = data.d.Title;
                var pid = study.containedFormCollection[0].containedForm.formQuestionCollection[0].question.questionsID;
                console.log("User Title:" + title + "     pid:"+pid);
                //Set the PI to the LocalSite Investigator
                $("#QID_"+pid).prop('value', title);
                //Disable text area
                $("#QID_"+pid).prop('disabled', true);  
		changedQuestions.add(pid);             
         });
    }    
};

function printableSectionsBuilder() {
	sendREST("GET", restPath.concat("study/" + assignedID + "/responses/" + targetStage + "/rollup"), null, function(responseRollup) {
		rollup = responseRollup;
		var targetSection, validityBySection = rollup.formValidationReport.formStatusCollection;
		rollupAnswers = new HashSet();
		rollupQuestions = new HashSet();
		for (var response = 0; response < rollup.responses.length; response++) {
			//adding selected radios and checkboxes
			if (rollup.responses[response].answersID !== undefined)
				rollupAnswers.add(rollup.responses[response].answersID);
			//adding questions regardless
			rollupQuestions.add(rollup.responses[response].questionsID);
		}

		for (targetSection = 0; targetSection < validityBySection.length; targetSection++) {
			switch (validityBySection[targetSection].status) {
			case "EMPTY":
			case "NOT_APPLICABLE":
				break;
			default:
				var section = $($.parseHTML("<div class=container id=section-" + targetSection + ">" +
										        "<div class=row>" +
										            "<div class=col-xs-9/>" +
										        "</div>" +
										    "</div>")[0]).appendTo("body");
				printColumnBuilder(targetSection, section);
			}
		}
	});
};

//sets up the structure of the question area; includes header,
//questions, and button dock (progress buttons)
function columnBuilder(targetSection){
    var section, pageHeader, formContent, progressContainer;

    section = study.containedFormCollection[targetSection];

    //page header
    pageHeader = document.createElement("div");
    pageHeader.setAttribute("class", "page-header");
    pageHeader.setAttribute("tabindex", "0");
    pageHeader = $(pageHeader).appendTo("div.col-xs-9");

    headerBuilder(targetSection, pageHeader);

    //questions
    formContent = document.createElement("div");
    formContent.setAttribute("class", "formContent");
    formContent = $(formContent).appendTo("div.col-xs-9");

    if(currentFormType == "Parent"){
        if((targetSection == 1) || (targetSection == 2) || (targetSection == 5) || (targetSection == 6) || (targetSection == 7) || (targetSection == 11))
            disclaimerBuilder(targetSection);
    }

    questionBuilder(section, formContent);
    
    //progress
    progressContainer = document.createElement("div");
    progressContainer.setAttribute("class", "progress-container");
    progressContainer.setAttribute("aria-live", "assertive");
    $('div.col-xs-9').append(progressContainer);
    
    //buttons
    $('div.col-xs-9').append("<div class=button-container/>");

    progressBuilder();
};

//Sets up the structure of the sidebar; includes section buttons, print and upload buttons,
//and review and submit buttons.
function sideColumnBuilder(targetSection){
    var actionBar, wsBar;

    //action bar
    actionBar = document.createElement("div");
    actionBar.setAttribute("class", "actionbar");
    $('.toolbar').append(actionBar);

    actionBarBuilder(targetSection);

    //well sidebar
    wsBar = document.createElement("div");
    wsBar.setAttribute("class", "well sidebar");
    $('.toolbar').append(wsBar);

    if(assignedID != "1"){
        sendREST("GET", siteUrl.concat("_api/web/GetFolderByServerRelativeUrl('Shared%20Documents/"+assignedID+"/Study%20Team')/Files"), null, function(returnedFiles){
            //attachments = filterChecklists(returnedFiles.d.results, "-RAMS-");
			attachments = returnedFiles.d.results;
            wellSidebarBuilder(targetSection, attachments.length);
        });
    }else{
        wellSidebarBuilder(targetSection, "0");
    }
};

//creating the disclaimer that is seen at the top of certain page
function disclaimerBuilder(targetSection){
    var cont, close, hide, closer, paragraph;
    cont = document.createElement("div");
    cont.setAttribute("class", "well notificationArea alert-dismissible fade in");
    cont.setAttribute("role", "alertdialog");
    cont.setAttribute("aria-describedby", "disclaimerText");

    close = document.createElement("button");
    close.setAttribute("data-dismiss", "alert");
    close.setAttribute("class", "close");
    close.setAttribute("type", "button");

    hide = document.createElement("span");
    hide.setAttribute("aria-hidden", "true");
    var text = document.createTextNode("x");
    hide.appendChild(text);

    closer = document.createElement("span");
    closer.setAttribute("class", "sr-only");
    var text = document.createTextNode("Close")
    closer.appendChild(text);

    close.appendChild(hide);
    close.appendChild(closer);

    paragraph = document.createElement("p");
    paragraph.setAttribute("id", "disclaimerText");

    var text;
    if(targetSection == 1){
        text = "Disclaimer: Answers to some questions in this section will require your answer to additional questions in subsequent sections of the Research Study Application.";
    }else if(targetSection == 2){
        text = "Disclaimer: Answers in this section may be hidden based on your answers in Section A";
    }else if(targetSection == 5){
        text = "Disclaimer: Based on your answers in Section B, you are required to answer these additional questions.";
    }else if(targetSection == 6){
        text = "Disclaimer: Based on your answers in Section B, you are required to answer these additional questions.";
    }else if(targetSection == 7){
        text = "Disclaimer: Based on your answers in Section B, you are required to answer these additional questions.";
    }else if(targetSection == 11){
        text = "Disclaimer: Based on your answers in Section B, you are required to answer these additional questions.";
    }
    paragraph.textContent = text;

    cont.appendChild(close);
    cont.appendChild(paragraph);
    $('.formContent').append(cont);
};

//builds the header that displays information about a study and section.
function headerBuilder(targetSection, headerArea) {
    var appTitle, id, section, sectionContainer, genInfo;

    //Study title
    appTitle = document.createElement("h2");
    appTitle.setAttribute("class", "applicationTitle");
    
    //Sets up the default study title in the header
    if(studyTitle == ""){
        var text = document.createTextNode("New Research Study Application");
    }else{
        var text = document.createTextNode(studyTitle);
    }
    appTitle.appendChild(text);

    //Study ID
    id = document.createElement("small");
    
    //Sets up the default study ID in the header
    if(assignedID == "1"){
        var text = document.createTextNode(" ID: TBD");
    }else{
        var text = document.createTextNode(" ID: " + assignedID);
    }
    id.appendChild(text);
    appTitle.appendChild(id);

    headerArea.append(appTitle);

    //Current Section Display
    section = document.createElement("h3");
    section.setAttribute("class", "sectionNumber");
    
    if((targetSection != "Sites") && (targetSection != "Personnel") && (targetSection != "Attachments")){
        var sectionTitle = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
        var text = document.createTextNode("Section " + sectionTitle.charAt(targetSection));
    }else{
        var text = document.createTextNode(targetSection);
    }


    section.appendChild(text);
    
    headerArea.append(section);
    
    //General Information Display
    sectionContainer = document.createElement("div");
    sectionContainer.setAttribute("class", "sectionContainer");

    genInfo = document.createElement("h5");
    genInfo.setAttribute("class", "sectionTitle");

    if((targetSection != "Sites") && (targetSection != "Personnel") && (targetSection != "Attachments")){
       var text = document.createTextNode(study.containedFormCollection[targetSection].containedForm.title);
       genInfo.appendChild(text);
    }
    
    
    sectionContainer.appendChild(genInfo);
    
    if (readOnlyState) //Setting up a placeholder for completion status
        $(sectionContainer).append("<h5 class=sectionLocation>Application stage " + targetStage + ": " + currentStudyStatus[targetStage - 1].studyState.name + "</h5>");
	else
        $(sectionContainer).append("<h5 class=sectionLocation>Completed: 0/11</h5>");

    headerArea.append(sectionContainer);
};

//sets up the structure of the question areas and headers,
//questions and responses, but no buttons
function printColumnBuilder(targetSection, sectionArea) {
    var pageHeader, formContent, progressContainer;
    var section = study.containedFormCollection[targetSection];
	var colXs9 = sectionArea.find("div.col-xs-9");

    //page header
    var pageHeader = $($.parseHTML("<div class=page-header tabindex=0/>")[0]).appendTo(colXs9);
    headerBuilder(targetSection, pageHeader);

    //questions
    var formContent = $($.parseHTML("<div class=formContent/>")[0]).appendTo(colXs9);
    questionBuilder(section, formContent);
};

//Creates a general warning to display. Takes in a message and a warning type,
//which will move the user to the progress bar when called.
function insertWarning(message, type){
    var warnCont, bolded, warnClose, warnSpan, text, breaker;
    
    //Removing any traces of previous warnings.
    $('.alert').remove();

    warnCont = document.createElement("div");
    warnCont.setAttribute("class", "alert "+type);
    warnCont.setAttribute("role", "alert");
    warnCont.setAttribute("aria-role", "assertive");

    //close warning
    warnClose = document.createElement("button");
    warnClose.setAttribute("type", "button");
    warnClose.setAttribute("class", "close");
    warnClose.setAttribute("data-dismiss", "alert");
    warnClose.setAttribute("aria-label", "Close");

    warnSpan = document.createElement("span");
    warnSpan.setAttribute("aria-hidden", "true");

    text = document.createTextNode("x");
    warnSpan.appendChild(text);
    warnClose.appendChild(warnSpan);
    warnCont.appendChild(warnClose);

    bolded = document.createElement("strong");

    //Creating different content based on what is requested This isn't warnCont.innerHTML 
    //because it wipes out everything that's in the div instead of appending to it.
    if(type == "alert-warning"){
        text = document.createTextNode("Warning!");
    }else if(type == "alert-success"){
        text = document.createTextNode("Congratulations!");
    }

    //bolding the warning header
    bolded.appendChild(text);
    warnCont.appendChild(bolded);

    //break
    breaker = document.createElement("br");
    warnCont.appendChild(breaker);

    //passed warning message
    text = document.createTextNode(message);
    warnCont.appendChild(text);

    $('.progress-container').prepend(warnCont);
    $('.progress-container').show();

    //JQUERY moving page to the generated warning
    if(type == "alert-warning"){
        $('html, body').animate({
            scrollTop: $(document).height()
        }, 1000);
    }

    $(warnCont).parent().delay("3000").fadeOut("3000");
};

//connects to a rest endpoint and either sends or
//receives data
function sendREST(httpMethod, endpoint, data, callback, spHttpMethod){
    var xmlResponse;
    
    //accounting for internet explorer's needs
    if(window.XMLHttpRequest){
    xmlResponse = new XMLHttpRequest();
    }else{
    xmlResponse = new ActiveXObject("Microsoft.XMLHTTP");
    }

    try{
        //setting up general headers
        xmlResponse.open(httpMethod, endpoint);
        xmlResponse.withCredentials = true;
        // xmlResponse.setRequestHeader("Content-Type", "application/json");
        xmlResponse.setRequestHeader("Accept", "application/json; odata=verbose");
        xmlResponse.setRequestHeader("X-RequestDigest", requestDigest);
        
        if((httpMethod == "PUT")||(httpMethod == "DELETE")){
            xmlResponse.setRequestHeader("sm_user", data);
            xmlResponse.send(null);
            
            //204 is the response status indicating success, while
            //403 indicates failure
            if(xmlResponse.status === 204){
                return true;
            }else if(xmlResponse.status === 403){
                return false;
            }
        }else if(httpMethod == "POST"){
            try{
                xmlResponse.setRequestHeader("Content-Type", "application/json; odata=verbose");
                
                if(spHttpMethod == "Merge"){
                    xmlResponse.setRequestHeader("X-HTTP-Method", "MERGE");
                    xmlResponse.setRequestHeader("If-Match", "*");
                }else if(spHttpMethod == "Delete"){
                    xmlResponse.setRequestHeader("X-HTTP-Method", "DELETE");
                }

                //sending data and alerting the user
                if(data){
                    //logMessageToULS("POST with Data - " + endpoint, "dynamicGeneration.js"); //show what data is being sent
                    xmlResponse.send(JSON.stringify(data));
					
                }else{
                    xmlResponse.send(null);
                }

                if(callback){
                    xmlResponse.onreadystatechange = function(){
                        if(xmlResponse.readyState === 4){

                            if(readOnlyState == false){
                                insertWarning('You have successfully saved your responses', 'alert-success');
                            	$("#saveAppProgress").prop("disabled", true);
								setTimeout(function(){$('html, body').animate({scrollTop: $("#insert").offset().top}, 2000);}, 4000); //scroll back to the top after displaying success message
                            }

                            if((xmlResponse.status === 200) && (xmlResponse.responseText)){
                                //response has content
                                xmlResponse = JSON.parse(xmlResponse.responseText);
                                callback(xmlResponse);
                            }else{
                                //logMessageToULS(httpMethod + "-" + endpoint + "-" + xmlResponse.status, "dynamicGeneration.js");
                                callback();
                            }
                        }
                    };
                }
            }catch(e){
                // alert(e.toString());
				//logMessageToULS(httpMethod + "-" + endpoint + "-" + e.toString(), "dynamicGeneration.js");
            }
        }else if(httpMethod == "GET"){
            //retrieving the needed data
            xmlResponse.onreadystatechange = function(){
                if(xmlResponse.readyState === 4){
                    if(xmlResponse.status === 200){ 
                        try{
                             xmlResponse = JSON.parse(xmlResponse.responseText);
                             if(callback)
                                callback(xmlResponse);
                        }catch(e){
                            alert(e.toString());
                        }   
                    }else{
                        if((xmlResponse.status !== 204) && (xmlResponse.status !== 1223))
                         alert(xmlResponse.status);
                    }
                }
            };
            xmlResponse.send(null);
            //passing the needed data to the function that is requesting it
            return xmlResponse;
        }

    }catch(e){
       alert(e.toString());
    }
};

//Takes the response from the database and builds the questions displayed
//in the application.
function questionBuilder(section, divFormContent) {
    //setting up a fresh set to keep track of questions that have been
    //changed while the user is in a particular section.
    changedQuestions = new HashSet();
    var panelGroup, users;
    
    //filtering through each of the questions in a section to build them individually
    for(var i=0; i<section.containedForm.formQuestionCollection.length; i++){
    var form, formGroup, textLabel, text, input, toolSpan, field, legend, reqText, reqSpan, bolded, breaker;
    var formQuestion = section.containedForm.formQuestionCollection[i];
    var currentValues = new Hashtable();
    var answeredValues = [];
    //var currentAnswers = new HashSet();
    var currentAnswers = [];
    var checkedAnswers = 0;

    form = document.createElement("form");
    
    //div containing complete questions
    formGroup = document.createElement("div");
    formGroup.setAttribute("class", "form-group");
    formGroup.setAttribute("aria-live", "assertive");

    //holds the required astrik, question text, and tooltip
    textLabel = document.createElement("label");
    textLabel.setAttribute("tabindex", "0");


    //required asterisk
    // XXX We hide this from a screen reader.  Should the question not be in tabindex=0 if it is disabled?
    if (formQuestion.requiredPredecessorAnswersID == null) {
		form.setAttribute("rams-required", "true");
        reqSpan = document.createElement("span");
        reqSpan.setAttribute("class", "required");
        reqSpan.setAttribute("aria-hidden", "true");
        reqSpan.textContent = "*";
        textLabel.appendChild(reqSpan);
        
        reqSpan = document.createElement("span");
        reqSpan.setAttribute("class", "required sr-only");
        reqSpan.textContent = "A response is required.";
        textLabel.appendChild(reqSpan);
    } else {
		form.setAttribute("rams-required", "false");
        reqSpan = document.createElement("span");
        reqSpan.setAttribute("class", "sr-only");
        reqSpan.textContent = "A response is not required.";
        textLabel.appendChild(reqSpan);
    }

    //question text. We see the introdocution of QID_ (Question IDs) and later
    //we will see AID_ (Answer IDs). These have been put in to comply 508 standards that 
    //input id attributes must start with a letter.
    textLabel.setAttribute("for", "QID_" + formQuestion.question.questionsID);
    text = document.createTextNode(formQuestion.formSequencePosition + ". " + formQuestion.question.questionHyperText);
    textLabel.appendChild(text);

    //tooltip logic
    if((formQuestion.question.helpHyperText) && (readOnlyState == false)){
        toolSpan = document.createElement("span");
        toolSpan.setAttribute("class", "glyphicon glyphicon-question-sign");
        toolSpan.setAttribute("tabindex", "0");
        toolSpan.style.cursor = "help";
        toolSpan.setAttribute("data-toggle", "popover");
        toolSpan.setAttribute("data-placement", "top");
        toolSpan.setAttribute("data-content", formQuestion.question.helpHyperText);
        $(toolSpan).popover({trigger: "hover focus manual click", delay: {show: 250}});

        textLabel.appendChild(toolSpan);
    }

    formGroup.appendChild(textLabel);

    //Building the questions based on their type: radio, checkbox, select, textarea, file button, etc
    if((formQuestion.question.responseFormat.name == "radio") || (formQuestion.question.responseFormat.name == "checkbox")){
  
        //question input for radios and checkboxes
        field = document.createElement("fieldset");
        //legend = textLabel;
        field.setAttribute("id", "QID_" + formQuestion.question.questionsID);
        field.setAttribute("name", "QID_" + formQuestion.question.questionsID);
        //legend.setAttribute("for", "QID_" + formQuestion.question.questionsID);
        
        //building the individual radio/checkbox buttons one by one.
        for(var j=0; j<formQuestion.question.answerCollection.length; j++){
            
        	//used to determine pixels needed for answer
            var answerValueLength = (formQuestion.question.answerCollection[j].value).length;
            var tinyAnswer = (answerValueLength < 5);
            var smallAnswer = (answerValueLength >= 5) && (answerValueLength < 18);
            var mediumAnswer = (answerValueLength >= 18) && (answerValueLength < 100);
            var neededLength = 8 * answerValueLength; 
            
            var answerLabel = document.createElement("label");
            if(formQuestion.question.responseFormat.name == "radio"){
               answerLabel.setAttribute("class", "radio");
            }else if(formQuestion.question.responseFormat.name == "checkbox"){
                answerLabel.setAttribute("class", "checkbox");
            }
            
            //set label width for radio or checkbox based on answer length
            if(tinyAnswer){
            	answerLabel.style.width = "60px";
            }else if(smallAnswer){
            	answerLabel.style.width = "150px";
            }else if(mediumAnswer){
            	answerLabel.style.width = neededLength + "px";
            }else{ //answer is 100 or more characters long
            	answerLabel.style.width = "700px"; //keep long answer within form margin
            }
            
            answerLabel.setAttribute("for", "AID_" + formQuestion.question.answerCollection[j].answersID);
            
            //putting together general structure
            var input = document.createElement("input");
            input.setAttribute("type", formQuestion.question.responseFormat.name);
            input.setAttribute("name", "QID_" + formQuestion.question.questionsID + "_multi");
            input.setAttribute("id", "AID_" + formQuestion.question.answerCollection[j].answersID);

            //disabling questions if the study is in f
            if(readOnlyState){
                input.setAttribute("disabled", true);
            }

            //Specifying the method to notify which questions are changed. This method helps group radio buttons
            //together, while allowing checkboxes to be saved individually. 
            if(formQuestion.question.responseFormat.name == "checkbox")
                input.setAttribute("title", formQuestion.question.answerCollection[j].sequencePosition);
            input.setAttribute("onchange", "Function(checkEnableSaveButton("+formQuestion.question.questionsID+"))");

            if((rollupAnswers.contains(formQuestion.question.answerCollection[j].answersID)) && (rollupQuestions.contains(formQuestion.question.questionsID))) {
                input.checked = true;
                checkedAnswers++;
                answeredValues.push(formQuestion.question.answerCollection[j].value);
            }

            if((targetStage != 1) && (previousStageAnswers.containsKey(formQuestion.question.answerCollection[j].answersID)) && (rollupAnswers.contains(formQuestion.question.answerCollection[j].answersID) == false)){
                //console.log("inserting into currentValues:" + JSON.stringify(formQuestion.question.answerCollection[j]));
                currentValues.put(formQuestion.question.answerCollection[j].answersID, formQuestion.question.answerCollection[j].value);
            }
        
            var value = document.createTextNode(formQuestion.question.answerCollection[j].value);
            
            answerLabel.appendChild(input);
            answerLabel.appendChild(value);
            
            field.appendChild(answerLabel);
            // XXX NVDA Reads this out the question twice if we do this.
            //if(formQuestion.question.responseFormat.name == "radio")
            //    field.setAttribute("role", "radiogroup");
            formGroup.appendChild(field);
            form.appendChild(formGroup);

            divFormContent.append(form);
        }

        if(readOnlyState){
            var insertHere = $('[name="QID_'+formQuestion.question.questionsID+'"]').parent();
            $('[name="QID_'+formQuestion.question.questionsID+'"]').remove();
            input = document.createElement("blockquote");
            if(answeredValues.length >= 1){
                for(var x=0; x<answeredValues.length; x++){
                    if(x >= 1){
                        var breaker = document.createElement("br");
                        input.appendChild(breaker);
                        var text = document.createTextNode(answeredValues[x]);
                    }else{
                        var text = document.createTextNode(answeredValues[x]);
                    }
                    input.appendChild(text);
                }
            }else{
                var italic = document.createElement("em");
                var text = document.createTextNode("No answer given.");
                italic.appendChild(text);
                input.appendChild(italic);
            }
            insertHere.append(input);
        }

        if(currentValues.keys().length >= 1){
            panelGroup = generatePreviousResponses(null, currentValues);
            formGroup.appendChild(panelGroup);
        }

    }else if(formQuestion.question.responseFormat.name == "select"){
        form.setAttribute("role", "form")
        form.appendChild(formGroup);
        
        //setting up the general structure of a drop down
        input = document.createElement("select");
        var inputOption = document.createElement("option");
        inputOption.setAttribute("value", "none");
        var text = document.createTextNode("none");
        inputOption.appendChild(text);
        input.appendChild(inputOption);

        //populating drop down based on users grabbed from the database
        users = ramsUsers.values();
        for(var j=0; j<users.length; j++){
            inputOption = document.createElement("option");
            inputOption.setAttribute("value", users[j].Title);
            text = document.createTextNode(users[j].Title);
            inputOption.appendChild(text);
            input.appendChild(inputOption);
        }

        input.setAttribute("name", "QID_" + formQuestion.question.questionsID);
        input.setAttribute("class", "form-control normal select");
        input.setAttribute("onchange", "checkEnableSaveButton("+formQuestion.question.questionsID+")");
        //input.setAttribute("onkeypress", "changedQuestions.add("+formQuestion.question.questionsID+")");
        
        //disabling question if the study is in review
        if(readOnlyState){
            input.setAttribute("disabled", true);
        }

        if(rollup.responses){
            var responseFound = false;
            //changing which option in the dropdown is initially selected
            for(var x=0; x<rollup.responses.length; x++){
                if(rollup.responses[x].questionsID == formQuestion.question.questionsID){
                    if((targetStage != 1) && ((previousStageQuestions.get(formQuestion.question.questionsID)).response != rollup.responses[x].response))
                        currentValues.put(formQuestion.question.questionsID, (previousStageQuestions.get(formQuestion.question.questionsID)).response);
                    answeredValues.push(rollup.responses[x].response);
                    responseFound = true;
                    if(readOnlyState){
                        input = document.createElement("blockquote");
                        var text = document.createTextNode(rollup.responses[x].response);
                        input.appendChild(text);
                    }else{
                        input.value = rollup.responses[x].response;
                    }
                }
            }
            if((readOnlyState == true) && (responseFound == false)){
                input = document.createElement("blockquote");
                var italic = document.createElement("em");
                var text = document.createTextNode("No answer given.");
                italic.appendChild(text);
                input.appendChild(italic);                
            }   
        }

        formGroup.appendChild(input);

        if(currentValues.keys().length >= 1){
            panelGroup = generatePreviousResponses(currentValues, null);
            formGroup.appendChild(panelGroup);
        }

        divFormContent.append(form);

    }else if((formQuestion.question.responseFormat.name == "button")){
        var uploadInput, uploadLink, uploadIcon;
        var noFile = true;
        
        //setting up the general structure for a file upload button
        form.setAttribute("role", "form");

        //setting up the upload button (Section C, Question 5)
        uploadInput = document.createElement("input");
        uploadInput.setAttribute("id", "upload");
        uploadInput.setAttribute("name", "QID_" + formQuestion.question.questionsID);
        uploadInput.setAttribute("type", "file");
        
        if(rollup.responses){
            var responseFound = false;
            //looking for responses to populate the textarea with
            for(var x=0; x<rollup.responses.length; x++){
                if(rollup.responses[x].questionsID == formQuestion.question.questionsID){
                    responseFound = true;
                    if(readOnlyState){
                        uploadInput = document.createElement("blockquote");
                        var text = document.createTextNode(rollup.responses[x].response);
                        uploadInput.appendChild(text);                      
                    }else{
                        var text = document.createTextNode("Uploaded File: " + rollup.responses[x].response);
                        formGroup.appendChild(text);
                        uploadInput.setAttribute("disabled", "disabled");                       
                    }
                }
            }
            if((readOnlyState == true) && (responseFound == false)){
                uploadInput = document.createElement("blockquote");
                var italic = document.createElement("em");
                var text = document.createTextNode("No file uploaded.");
                italic.appendChild(text);
                uploadInput.appendChild(italic);
            }
        }

        if(readOnlyState){
            uploadInput.setAttribute("disabled", "disabled");
        }


        //attaching the upload button
        formGroup.appendChild(uploadInput);

        form.appendChild(formGroup);
        divFormContent.append(form);
        
    }else{
        //question input for everything else, which should cover textares. 
        form.setAttribute("role", "form");
        form.appendChild(formGroup);

        //setting up the general structure for a textarea
        if(formQuestion.question.responseFormat.name == "textarea"){
            input = document.createElement("textarea");
            input.setAttribute("rows", "10");
        }else{
            input = document.createElement("input");
            input.setAttribute("type", formQuestion.question.responseFormat.name);
        }

        //setting up the general structure for a textarea
        input.setAttribute("name", "QID_" + formQuestion.question.questionsID);
        input.setAttribute("id", "QID_" + formQuestion.question.questionsID); // Still used?
        input.setAttribute("class", "form-control normal");
        input.setAttribute("onchange", "Function(checkEnableSaveButton("+formQuestion.question.questionsID+"))");
        //making sure the textarea is disabled if the application is in review
        if(readOnlyState){
            input.setAttribute("disabled", true);
        }

        if(rollup.responses){
            var responseFound = false;
            //looking for responses to populate the textarea with
            for(var x=0; x<rollup.responses.length; x++){
                if(rollup.responses[x].questionsID == formQuestion.question.questionsID){
                    if((targetStage != 1)&&(previousStageQuestions.get(formQuestion.question.questionsID))&&((previousStageQuestions.get(formQuestion.question.questionsID)).response != rollup.responses[x].response))
                        currentValues.put(formQuestion.question.questionsID, (previousStageQuestions.get(formQuestion.question.questionsID)).response);
                    answeredValues.push(rollup.responses[x].response);
                    responseFound = true;
                    if(readOnlyState){
                        input = document.createElement("blockquote");
                        var text = document.createTextNode(rollup.responses[x].response);
                        input.appendChild(text);
                    }else{
                        input.value = rollup.responses[x].response;
                    }
                }
            }
            if((readOnlyState == true) && (responseFound == false)){
                input = document.createElement("blockquote");
                var italic = document.createElement("em");
                var text = document.createTextNode("No answer given.");
                italic.appendChild(text);
                input.appendChild(italic); 
            }
        }



        formGroup.appendChild(input);

        if(currentValues.keys().length >= 1){
            //generatePreviousResponses(currentValues, null);
            panelGroup = generatePreviousResponses(currentValues, null);
            formGroup.appendChild(panelGroup);
        }

        divFormContent.append(form);
    }

    //checking to see if the question has a dependency on another answer   
    if (formQuestion.requiredPredecessorAnswersID)
        questionRequirement(formQuestion, input);

    //making sure the question is completely disabled if the application is in review
    if(readOnlyState){
        input.setAttribute("disabled", true);
    }

    }
};

function generatePreviousResponses(buildQuestion, buildAnswers){
    //console.log("getting into previous responses. questions: " + buildQuestion + ", answers: " + buildAnswers);
    var panelGroup, panel, panelHeading, panelTitle, panelAnchor, panelDiv, panelBody, text, breaker, bold;
    var key = "key";

    if(buildQuestion != null){
        var find = buildQuestion.keys();
        var question = previousStageQuestions.get(find[0]);
    }else{
        var find = buildAnswers.keys();
        var question = previousStageAnswers.get(find[0]);
    }

    panelGroup = document.createElement("div");
    panelGroup.setAttribute("class", "panel-group");
    panelGroup.setAttribute("id", "accordion"+question.questionsID);
    panelGroup.setAttribute("role", "tablist");
    panelGroup.setAttribute("aria-multiselectable", "true");

    panel = document.createElement("div");
    panel.setAttribute("class", "panel panel-default");

    panelHeading = document.createElement("div");
    panelHeading.setAttribute("class", "panel-heading");
    panelHeading.setAttribute("role", "tab");
    panelHeading.setAttribute("id", "heading"+question.questionsID+key);

    panelTitle = document.createElement("h4");
    panelTitle.setAttribute("class", "panel-title");

    panelAnchor = document.createElement("a");
    panelAnchor.setAttribute("data-toggle", "collapse");
    panelAnchor.setAttribute("data-parent", "#accordion"+question.questionsID);
    panelAnchor.setAttribute("href", "#collapse"+question.questionsID+key);
    panelAnchor.setAttribute("aria-expanded", "false");
    panelAnchor.setAttribute("aria-controls", "collapse"+question.questionsID+key);

    text = document.createTextNode("Answer from " + question.updatedAt.split("T")[0]); 
    panelAnchor.appendChild(text);
    panelTitle.appendChild(panelAnchor);
    panelHeading.appendChild(panelTitle);
    panel.appendChild(panelHeading);

    panelDiv = document.createElement("div");
    panelDiv.setAttribute("id", "collapse"+question.questionsID+key);
    panelDiv.setAttribute("class", "panel-collapse collapse");
    panelDiv.setAttribute("role", "tabpanel");
    panelDiv.setAttribute("aria-labelledby", "heading"+question.questionsID+key);

    panelBody = document.createElement("div");
    panelBody.setAttribute("class", "panel-body");

    bold = document.createElement("b");
    text = document.createTextNode("You previously answered: ");
    bold.appendChild(text);
    panelBody.appendChild(bold);

    breaker = document.createElement("br");
    panelBody.appendChild(breaker);

    if(buildQuestion == null){
        buildAnswers.each(function(displayID, displayText){
            text = document.createTextNode(displayText);
            breaker = document.createElement("br")
            panelBody.appendChild(text);
            panelBody.appendChild(breaker);
        });
    }else{
        var text = document.createTextNode(question.response);
        panelBody.appendChild(text);
    }
            
    panelDiv.appendChild(panelBody);
    panel.appendChild(panelDiv);

    panelGroup.appendChild(panel);

    return panelGroup;
};

//checks to see if there are any unsaved questions within
//a section and notifies the user when they try to change sections
function checkSave(targetSection){
    if(changedQuestions.isEmpty()){
       sectionBuilder(targetSection);
    }else{
        if($('.alert-warning').length != 0){
            sectionBuilder(targetSection);
        }else{
            insertWarning("You have unsaved responses. Please click the Save Progress button at the bottom of the page or your changes will be lost.", "alert-warning");
        }
    }
}

//some questions are optional, this goes through the optional questions and
//sets up the proper dependencies on the front end to allow for instant activation
//and deactivation of questions.
function questionRequirement(formQuestion, input){
   
    //general queries to grab parent question
    var parentAnswer = $('#AID_'+formQuestion.requiredPredecessorAnswersID);
    var radioPair, span;
    
    //checkboxes have a listener on the one checkbox, but radios need a 
    //listener to turn on the question and a listener to turn off the question.
    //this requires us to query the yes/no radio buttons and attach a listener to each.
    if(parentAnswer.attr("type")=="checkbox"){
        if((parentAnswer.attr('onclick')) == null) {
            parentAnswer.attr("onclick", "activateQuestion("+formQuestion.requiredPredecessorAnswersID+")");
            //parentAnswer.attr("onkeypress", "activateQuestion("+formQuestion.requiredPredecessorAnswersID+")");
        }
    }else if(parentAnswer.attr("type")=="radio"){
        //radioPair = $('[name="'+($('#AID_'+formQuestion.requiredPredecessorAnswersID).attr("name"))+'"]');
        radioPair = $('[for="AID_'+formQuestion.requiredPredecessorAnswersID+'"]').parent();
        if((radioPair.attr('onclick')) == null){
            for(var j=0; j<radioPair.length; j++){
                radioPair[j].setAttribute("onclick", "activateQuestion("+formQuestion.requiredPredecessorAnswersID+")");
                //radioPair[j].setAttribute("onkeypress", "activateQuestion("+formQuestion.requiredPredecessorAnswersID+")");
            }
        }else{
            var multipleDependency = true;
           
            for(var j=0; j<radioPair.length; j++){
                var lookupID = parseInt(radioPair[j].getAttribute("id"));
                //checking to see if radio buttons in the same question
                //have different dependencies. 
                if((dependency.containsKey(lookupID))  ){
                    if(lookupID != formQuestion.requiredPredecessorAnswersID){
                        
                        //building the consolodated string of IDs that need to be updated
                        var changeString, activateString;
                        activateString = "Function(";
                        for(var x=0; x<radioPair.length; x++){
                            var secondLookup = parseInt(radioPair[x].getAttribute("id"));
                            activateString += "activateQuestion(" + secondLookup + ")";
                        }
                        activateString += ")";
                        activateString = activateString.replace(")a", "),a");
                        
                        //updating the activation attribute
                        for(var x=0; x<radioPair.length; x++){
                            radioPair[x].setAttribute("onclick", activateString);
                            //radioPair[x].setAttribute("onkeypress", activateString);
                        }
                    }
                }else{
                    multipleDependency = false;
                }
            }
        }
    }
    
    //We want to make sure that all children are disabled when their parents are disabled.
    if(parentAnswer.attr("disabled") == "disabled"){
        $('[name="QID_'+formQuestion.question.questionsID+'"]').attr("disabled", true);
        $('[name="QID_'+formQuestion.question.questionsID+'"]').parent().parent().attr("rams-required", false);
        $('[name="QID_'+formQuestion.question.questionsID+'"]').parent().find("span.required").remove();
    }else{
        $('[name="QID_'+formQuestion.question.questionsID+'"]').parent().parent().attr("rams-required", true);
        span = document.createElement("span");
        span.setAttribute("class", "required");
        span.setAttribute("aria-hidden", "true");
        span.textContent = "*";
        //$('[name="QID_'+formQuestion.question.questionsID+'"]').before(span);
        $('[name="QID_'+formQuestion.question.questionsID+'"]').parent().children().first().prepend(span);

        span = document.createElement("span");
        span.setAttribute("class", "required sr-only");
        span.textContent = "A response is required.";
        //$('[name="QID_'+formQuestion.question.questionsID+'"]').before(span);
        $('[name="QID_'+formQuestion.question.questionsID+'"]').parent().children().first().prepend(span);
    }

    //Below we set up a data structure to hold parent/child relationships. This includes setting up
    //a hash map where they key is a question ID and the value is a set of question IDs that the key effects

    //checking to see if there is already an established key for this answer
    if(dependency.containsKey(formQuestion.requiredPredecessorAnswersID)){
    
        //checking to see if the parent answer is checked or not, which directly affects whether the child is active/deactive
        if( ((parentAnswer.is(':checked')) == false) && ((rollupAnswers.contains(formQuestion.requiredPredecessorAnswersID))==false) ) {
            if((input.getAttribute("type") == "radio") ||(input.getAttribute("type") == "checkbox")){
                $('[name="QID_'+formQuestion.question.questionsID+'"]').attr("disabled", true);
                $('[name="QID_'+formQuestion.question.questionsID+'"]').parent().find("span.required").remove();
            }else{ 
                input.setAttribute("disabled",true);
                $('[name="QID_'+formQuestion.question.questionsID+'"]').parent().find("span.required").remove();
            }

            //points to an off page dependency. In this case we remove the question completely.
            if(((rollupAnswers.contains(formQuestion.requiredPredecessorAnswersID))==false) && ($('#AID_'+formQuestion.requiredPredecessorAnswersID).length == 0)){
                $('[name="QID_'+formQuestion.question.questionsID+'"]').parent().hide();
            }

        }
        
        //adding id to the set of questions affected by an answer.
        if(((dependency.get(formQuestion.requiredPredecessorAnswersID)).contains(formQuestion.question.questionsID)) == false) {
            (dependency.get(formQuestion.requiredPredecessorAnswersID)).add(formQuestion.question.questionsID);
        }
    
    }else{
        //instantiating the answer in the dependency map and giving it a set of questions it affects. 
        //Going through the same logic as above.
        var temp = new HashSet();
        temp.add(formQuestion.question.questionsID);
        dependency.put(formQuestion.requiredPredecessorAnswersID, temp);

        if( ((parentAnswer.is(':checked'))==false) && ((rollupAnswers.contains(formQuestion.requiredPredecessorAnswersID))==false) ) {
            if((input.getAttribute("type") == "radio") || (input.getAttribute("type") == "checkbox")){
                $('[name="QID_'+formQuestion.question.questionsID+'"]').attr("disabled", true);
                $('[name="QID_'+formQuestion.question.questionsID+'"]').parent().find("span.required").remove();
            }else{
                input.setAttribute("disabled",true);
                $('[name="QID_'+formQuestion.question.questionsID+'"]').parent().find("span.required").remove();
            }

            if(((rollupAnswers.contains(formQuestion.requiredPredecessorAnswersID))==false) && ($('#AID_'+formQuestion.requiredPredecessorAnswersID).length == 0)){
                $('[name="QID_'+formQuestion.question.questionsID+'"]').parent().hide();
            }
        }
    }
};

//This function toggles if a question is activated or
//deactivated.
function activateQuestion(answersId){
    var set = (dependency.get(answersId)).values();
    var span, text;
    
    if((targetState == "1") || (targetState == "3")){
        for(var i=0; i<set.length; i++){
            if($('#AID_'+answersId).attr("disabled")){
                $('[name="QID_'+set[i]+'"]').attr("disabled", true);
                $('[name="QID_'+set[i]+'"]').parent().parent().attr("rams-required", false);
                $('[name="QID_'+set[i]+'"]').parent().find("span.required").remove();
            }else{
                if(($('#AID_'+answersId).is(':checked')) == false){
                   $('[name="QID_'+set[i]+'"]').attr("disabled", true);
                   $('[name="QID_'+set[i]+'"]').parent().parent().attr("rams-required", false);
                   $('[name="QID_'+set[i]+'"]').parent().find("span.required").remove();
               }else{
                   $('[name="QID_'+set[i]+'"]').attr("disabled", false);
                   $('[name="QID_'+set[i]+'"]').parent().parent().attr("rams-required", true);
                    $('[name="QID_'+set[i]+'"]').parent().find("span.required").remove();
                    span = document.createElement("span");
			        span.setAttribute("class", "required");
			        span.setAttribute("aria-hidden", "true");
			        span.textContent = "*";
                    //$('[name="QID_'+set[i]+'"]').before(span);
                    $('[name="QID_'+set[i]+'"]').parent().children().first().prepend(span);

			        span = document.createElement("span");
			        span.setAttribute("class", "required sr-only");
			        span.textContent = "A response is required.";
                    //$('[name="QID_'+set[i]+'"]').before(span);
                    $('[name="QID_'+set[i]+'"]').parent().children().first().prepend(span);
               }
           }   
           //recursively going through the quetions to activate/deactivate children
           var setQuestions = $('[name="QID_'+set[i]+'"]');
            for(var j=0; j<setQuestions.length; j++){
                var setID = setQuestions[j].getAttribute("id");
                if(dependency.containsKey(parseInt(setID))){
                    activateQuestion(parseInt(setID));
                }
           }
        }
    }
};

//Builds the buttons that appear at the bottom of the page 
function progressBuilder(){
    var spButton, csButton;

    //Cancel Button. Takes the user back to the home page.
    csButton = document.createElement("button");
    csButton.setAttribute("value", "Cancel");
    csButton.setAttribute("type", "button");
    csButton.setAttribute("role", "button");
    csButton.setAttribute("class", "btn btn-default pull-left");
    csButton.setAttribute("title", "Cancel");
    //csButton.setAttribute("onclick", "location.href='../SiteAssets/irb-applications.html'");
    csButton.setAttribute("onclick", "location.href='../SitePages/irb%20applications.aspx'");
    //csButton.setAttribute("onkeypress", "location.href='../SitePages/irb%20applications.aspx'");

    var text = document.createTextNode("Cancel");
    csButton.appendChild(text);
    $('div.button-container').append(csButton);

    if(readOnlyState == false){
        //save progress button. Runs the function to package the user's responses.
        spButton = document.createElement("button");
        spButton.setAttribute("value", "Save Progress");
        spButton.setAttribute("type", "button");
        spButton.setAttribute("role", "button");
        spButton.setAttribute("class", "btn btn-default pull-right");
        spButton.setAttribute("title", "Save Progress");
        spButton.setAttribute("id", "saveAppProgress");
        spButton.setAttribute("onclick", "createResponses()");
        //spButton.setAttribute("onkeypress", "createResponses()");

        var text = document.createTextNode("Save Progress");
        
        spButton.appendChild(text);
        $('div.button-container').append(spButton);
    }
};

//Builds the buttons that appear on top of the sidebar which
//allow users to upload documents and print a section
function actionBarBuilder(targetSection){
    var actionTools;
    var uploadList, uploadLink, uploadIcon, uploadInput;

    //general structure for print button
    actionTools = document.createElement("ul");
    actionTools.setAttribute("class", "actionTools");
    if (assignedID != 1)
    	actionTools.appendChild(printMenuBuilder());

    //general structure for upload button
    //creating the normal button that stays hidden
    uploadInput = document.createElement("input");
    uploadInput.setAttribute("id", "upload-general");
    uploadInput.setAttribute("type", "file");
    uploadInput.setAttribute("name", "0000");
    uploadInput.style.display = "none";
    actionTools.appendChild(uploadInput);

    uploadList = document.createElement("li");

    //setting up the stylized button that triggers the usual
    //file upload button which is hidden.
    uploadLink = document.createElement("a");
    //uploadLink.setAttribute("href", "#");
    //uploadLink.setAttribute("onclick", "checkEnableSaveButton('0000'); $('#upload-general').trigger('click'); uploadFiles();"); //previous code (working)
    uploadLink.setAttribute("onclick", "triggerUploadModal()");
    //uploadLink.setAttribute("onkeypress", "Function($('#upload-general').trigger('click'), changedQuestions.add('0000'))");

    uploadLink.style.cursor = "pointer";
        
    uploadIcon = document.createElement("span");
    uploadIcon.setAttribute("class", "glyphicon glyphicon-upload");
    uploadLink.appendChild(uploadIcon);

    var text = document.createTextNode("Upload Document...");
    uploadLink.appendChild(text);

    uploadList.appendChild(uploadLink);
	//
	
    actionTools.appendChild(uploadList);

    $('div.actionbar').append(actionTools);
};

function printMenuBuilder() {
    var template = "<div class=dropdown>" +
	    	   "    <a id=printLabel href='#' data-toggle=dropdown role=button aria-haspopup=true aria-expanded=false>" +
		   "         <span class='glyphicon glyphicon-print'></span>" +
		   "         Print All Sections" +
		   "         <span class=caret></span>" +
		   "    </a>" +
		   "    <ul class=dropdown-menu aria-labelledby=printLabel>";

    var stage;
    for (stage = 1; stage <= currentStudyStatus.length; stage++) {
		template += "<li>"; 
		template += "<a target=_blank href='irb-applications-print.html?" + assignedID + "?" + stage + "'>Stage " + stage + ": " + currentStudyStatus[targetStage - 1].studyState.name;
		if (stage == targetStage)
			template += " (currently displayed)";
		template += "</a></li>";
    }
	template += "</ul></div>";
	return $.parseHTML(template)[0];
}

//creates the rest of the sidebar including the sections
//and the buttons that allow you to review and submit
function wellSidebarBuilder(targetSection, fileCount){
    var listGroup, lGroup;
        
    $('.list-group').remove();

    listGroup = document.createElement("div");
    listGroup.setAttribute("class", "list-group");

    //creating the sidebar menu button for each section
    for(var i=0; i<study.containedFormCollection.length; i++){
        var link = document.createElement("a");
        link.style.cursor = "pointer";
        link.setAttribute("tabindex", "0");

        //setting up the activated section styling
        if(i == targetSection){
            link.setAttribute("class", "list-group-item active sectionLink");
        }else{
            link.setAttribute("class", "list-group-item sectionLink");
        }
        
        var sectionTitle = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
        var title = study.containedFormCollection[i].containedForm.title;
        var text = document.createTextNode(sectionTitle.charAt(i) + ": " + title);
        link.appendChild(text);
        
        listGroup.appendChild(link);
    }
    
    $('div.well.sidebar').append(listGroup);

    lGroup = document.createElement("div");
    lGroup.setAttribute("class", "list-group");

    //setting up the Attachments button
    var link = document.createElement("a");
    link.style.cursor = "pointer";
    link.setAttribute("class", "list-group-item");
    //link.setAttribute("onkeypress", "refreshDisplay('Files')");
    link.setAttribute("onclick", "refreshDisplay('Files')");
    link.setAttribute("tabindex", "0");
    
    var text = document.createTextNode("Attachments");
    link.appendChild(text);
    
    var icon = document.createElement("span");
    icon.setAttribute("class", "badge");
    
    var text = document.createTextNode(fileCount);
    icon.appendChild(text);

    link.appendChild(icon);

    lGroup.appendChild(link);

    //setting up the Add Personnel button
    var link = document.createElement("a");
    link.style.cursor = "pointer";
    link.setAttribute("class", "list-group-item");
    link.setAttribute("onclick", "refreshDisplay('Personnel')");
    //link.setAttribute("onkeypress", "refreshDisplay('Personnel')");
    link.setAttribute("tabindex", "0");
    
    var text = document.createTextNode("Manage Personnel");
    link.appendChild(text);
    
    var icon = document.createElement("span");
    icon.setAttribute("class", "glyphicon glyphicon-chevron-right");
    
    link.appendChild(icon);

    lGroup.appendChild(link);

    /*Should only be set if this is a central applicaiton*/
    if((currentFormType == "Parent") && ((grabApplicationSiteType() == "Central") || (grabApplicationSiteType() == "Multi"))){
        //setting up the Local Site button
        var link = document.createElement("a");
        link.style.cursor = "pointer";
        link.setAttribute("class", "list-group-item");
        link.setAttribute("onclick", "refreshDisplay('Facility')");
        //link.setAttribute("onkeypress", "refreshDisplay('Facility')");
        link.setAttribute("tabindex", "0");
        
        var text = document.createTextNode("Local Site Application");
        link.appendChild(text);
        
        var icon = document.createElement("span");
        icon.setAttribute("class", "glyphicon glyphicon-chevron-right");
        
        link.appendChild(icon);

        lGroup.appendChild(link);
    }

    //setting up the Review & Submit button
    if(targetState == 1){
        var link = document.createElement("a");
        link.style.cursor = "pointer";
        link.setAttribute("class", "list-group-item");
        link.setAttribute("onclick", "reviewApp()");
        //link.setAttribute("onkeypress", "reviewApp()");
        link.setAttribute("tabindex", "0");
        
        //if(targetState == 1){
            var text = document.createTextNode("Review & Submit");
            link.appendChild(text);
	//}        

        var icon = document.createElement("span");
        icon.setAttribute("class", "glyphicon glyphicon-chevron-right");
        
        link.appendChild(icon);

        lGroup.appendChild(link);
    }

    $('div.well.sidebar').append(lGroup);
    
    //updating sidebar icons
    updateSidebarIcons(targetSection);
};

//organizes questions in sections to be either answered or unanswered and then
//reports to the user which questions they still need to fill out.
function validateQuestions(){
    var formsResponse, rollupResponse;

    formsResponse = study;
    rollupResponse = rollup;
    
    var form_id_questions_id_map = {};
    var questions_predecessor_map = {};
    var formValidCont, sectionCont, questionCont, text, anchor;
    var formTable, row, questionTable;

    formTable = document.createElement("ul");
    questionTable = document.createElement("ul");

    //putting together a map of parent/child questions
    for (var x = 0; x < formsResponse.containedFormCollection.length;x++) {
        for(var xx = 0; xx < formsResponse.containedFormCollection[x].containedForm.formQuestionCollection.length; xx++){
            if (formsResponse.containedFormCollection[x].containedForm.formsID in form_id_questions_id_map) {
              form_id_questions_id_map[formsResponse.containedFormCollection[x].containedForm.formsID].push(formsResponse.containedFormCollection[x].containedForm.formQuestionCollection[xx].question.questionsID)
            }else form_id_questions_id_map[formsResponse.containedFormCollection[x].containedForm.formsID] = [ formsResponse.containedFormCollection[x].containedForm.formQuestionCollection[xx].question.questionsID   ]; 
            
            if (formsResponse.containedFormCollection[x].containedForm.formQuestionCollection[xx].requiredPredecessorAnswersID) {
            questions_predecessor_map[formsResponse.containedFormCollection[x].containedForm.formQuestionCollection[xx].question.questionsID] = formsResponse.containedFormCollection[x].containedForm.formQuestionCollection[xx].requiredPredecessorAnswersID;
            }
        }
    }

    var form_id_empty = [];
    var form_id_incomplete = [];
    
    var sectionTitle = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    formValidCont = document.createElement("div");
    sectionCont = document.createElement("div");
    if (deletedHIPAA != ''){
		for (var x = 0; x<rollupResponse.formValidationReport.formStatusCollection.length; x++) {
           
				if (rollupResponse.formValidationReport.formStatusCollection[x].formsID == deletedHIPAA) {

					 rollupResponse.formValidationReport.formStatusCollection.splice(x, 1);
				}
		}
	}
    //grabbing questions that still need to be answered
    for(var x = 0; x<rollupResponse.formValidationReport.formStatusCollection.length; x++){
            
        if(rollupResponse.formValidationReport.formStatusCollection[x].status==="INCOMPLETE"){
            form_id_incomplete.push(rollupResponse.formValidationReport.formStatusCollection[x].formsID);
        
        }else if(rollupResponse.formValidationReport.formStatusCollection[x].status==="EMPTY"){
            form_id_empty.push(rollupResponse.formValidationReport.formStatusCollection[x].formsID);
            //notifying users of sections that are completely empty
            row = document.createElement("li");
            row.textContent = "Section " +sectionTitle.charAt(x)+ ": " + study.containedFormCollection[x].containedForm.title + " is empty";
            formTable.appendChild(row);
        }
    }

    formValidCont.appendChild(formTable);
    
    //below we grab questions that have been answered
    var filled_questions = [];

    for(var x = 0; x<rollupResponse.responses.length; x++){
       filled_questions.push(rollupResponse.responses[x].questionsID);
    }

    var filled_answers = [];

    for(var x = 0; x<rollupResponse.responses.length; x++){
        if(rollupResponse.responses[x].answersID)
            filled_answers.push(rollupResponse.responses[x].answersID);
    }
    
    function hasPredecessorAnswered(question){
        if (filled_answers.indexOf(questions_predecessor_map[question]) == -1){
            return false;
        }else{
            return true;
        }
    };
    
    var incomplete_forms_questions_map = {};

    //putting together a map of incomplete sections as the key and unanswered questions and the values
    for(var x = 0; x < form_id_incomplete.length; x++){
        for(var xx = 0; xx < form_id_questions_id_map[form_id_incomplete[x]].length; xx++){
            if(filled_questions.indexOf(form_id_questions_id_map[form_id_incomplete[x]][xx])==-1){
                if(!( form_id_questions_id_map[form_id_incomplete[x]][xx] in questions_predecessor_map )){
                    if ( form_id_incomplete[x] in incomplete_forms_questions_map ) {
                     incomplete_forms_questions_map[form_id_incomplete[x]].push(form_id_questions_id_map[form_id_incomplete[x]][xx]);
                    }else {
                     incomplete_forms_questions_map[form_id_incomplete[x]] = [ form_id_questions_id_map[form_id_incomplete[x]][xx] ];
                    }
                }else {
                    if(hasPredecessorAnswered(form_id_questions_id_map[form_id_incomplete[x]][xx])){
                        if ( form_id_incomplete[x] in incomplete_forms_questions_map ) {
                            incomplete_forms_questions_map[form_id_incomplete[x]].push(form_id_questions_id_map[form_id_incomplete[x]][xx]);
                        }else {
                             incomplete_forms_questions_map[form_id_incomplete[x]] = [ form_id_questions_id_map[form_id_incomplete[x]][xx] ];
                        }
                    } 
                }
            }
        }
    }

    //going through the map that was just created to notify the users of what specific questions still need to be answered.
    for(var x=0; x<study.containedFormCollection.length; x++){
        for(var i=0; i<form_id_incomplete.length; i++){
            if(form_id_incomplete[i] == study.containedFormCollection[x].containedForm.formsID){
                for(var y=0; y<study.containedFormCollection[x].containedForm.formQuestionCollection.length; y++){
                    for(var key in incomplete_forms_questions_map){
                        for(var j=0; j<incomplete_forms_questions_map[key].length; j++){
                            if(incomplete_forms_questions_map[key][j] == study.containedFormCollection[x].containedForm.formQuestionCollection[y].question.questionsID){
                                row = document.createElement("li");
                                row.textContent = "In Section " +sectionTitle.charAt(x)+ ", you still need to answer: " + study.containedFormCollection[x].containedForm.formQuestionCollection[y].question.questionHyperText;
                                questionTable.appendChild(row);
                            }
                        }
                    }
                }
            }
        }
    }

    formValidCont.appendChild(questionTable);


    //checking the completeness of the application. All of the sections have to be labled as complete
    var complete = true;
    var expedited_complete = true;
    for(var x=0; x<rollup.formValidationReport.formStatusCollection.length; x++){
        if((rollup.formValidationReport.formStatusCollection[x].status != "COMPLETE") && (rollup.formValidationReport.formStatusCollection[x].status != "NOT_APPLICABLE"))
            complete = false;
    }

    //if a user is submitting an application as an expedited study, then they need to meet the three requirements, which the below logic looks for
    if((currentFormType == "Parent") && (rollupAnswers.contains(study.containedFormCollection[0].containedForm.formQuestionCollection[5].question.answerCollection[1].answersID))){
        if(!(rollupAnswers.contains(study.containedFormCollection[2].containedForm.formQuestionCollection[1].question.answerCollection[0].answersID)))
            expedited_complete = false;

        if(!(rollupAnswers.contains(study.containedFormCollection[2].containedForm.formQuestionCollection[1].question.answerCollection[1].answersID)))
            expedited_complete = false;

        if(!(rollupAnswers.contains(study.containedFormCollection[2].containedForm.formQuestionCollection[1].question.answerCollection[2].answersID)))
            expedited_complete = false;
    }

    //finally, for a user to submit an application, they have to either be a PI or CO-PI
    if(targetState == "1"){
        if(complete){
            if(expedited_complete){
                if(((currentFormType != "Parent") && (currentFormType != "Local")) || ((currentUser.Title == grabPI()) || (currentUser.Title == grabCoPI))){
                    //setting up the structure for a user to submit their application
                    var submitCont = document.createElement("div");
                    //submitCont.setAttribute("action", "../SitePages/irb%20applications.aspx");

                    var breaker = document.createElement("br");
                    formValidCont.appendChild(breaker);

                    //inserting an official narrative for users to accept while submitting
                    var paragraph = document.createElement("p");
                    var text = document.createTextNode("I accept responsibility for assuring that this protocol will be conducted in compliance with ethical clinical practices and all applicable VA, IRB, FDA regulations, IRB and Institutional policies relative to the protection of the rights, welfare and safety of human subjects.  I acknowledge that I have the primary and ultimate responsibility for protecting the rights and welfare of research participants and that I understand the ethical principles of human subject protection.  I affirm that I have the competencies and adequate resources and facilities to carry out the proposed research and I attest that this application is scientifically and ethically sound.  Finally, all Conflicts of Interests have been disclosed.");
                    paragraph.appendChild(text);
                    submitCont.appendChild(paragraph);

                    var paragraph = document.createElement("p");
                    var text = document.createTextNode("In submitting this application, I certify the acknowledgements previously described and that the research team is qualified and credentialed to conduct this research study.  I and my study team will conduct and oversee this project in accordance with all ethical standards required by the VA for the conduct of human subjects research.");
                    paragraph.appendChild(text);
                    submitCont.appendChild(paragraph);

                    var submission = document.createElement("button");
                    submission.setAttribute("id", "submitApplication"); //add ID to button
                    submission.setAttribute("onclick", "submitIRB()");
                    //submission.setAttribute("onkeypress", "submitIRB()");
                    var text = document.createTextNode("Submit Application");
                    submission.appendChild(text);
                    submitCont.appendChild(submission);

                    formValidCont.appendChild(submitCont);
                }else{
                    var breaker = document.createElement("br");
                    formValidCont.appendChild(breaker);

                    //notifying users why their application is incomplete
                    var paragraph = document.createElement("p");
                    var text = document.createTextNode("You must be either the PI or CO-PI to submit an application");
                    paragraph.appendChild(text);
                    formValidCont.appendChild(paragraph);
                }
            }else{
                var breaker = document.createElement("br");
                formValidCont.appendChild(breaker);

                //notifying users why their application is incomplete
                var paragraph = document.createElement("p");
                var text = document.createTextNode("You have idenitfied your application as being expedited, however you haven't met all three expedited cagtegories outlined in Section C");
                paragraph.appendChild(text);
                formValidCont.appendChild(paragraph);
            }
        }else{
                var breaker = document.createElement("br");
                formValidCont.appendChild(breaker);

                //notifying users why their application is incomplete
                var paragraph = document.createElement("p");
                var text = document.createTextNode("You must complete the Research Study Application before you can submit.");
                paragraph.appendChild(text);
                formValidCont.appendChild(paragraph);
        }
    }
    return formValidCont;
};

//changes the status of the application from "draft" to "review"
function submitIRB(){
    var cirb, appLink;
    var subsiteUrl;
    
    $("#submitApplication").prop("disabled", true); //disable the "Submit Application" button for the application
    $("#closeWindow").prop("disabled", true); //disable the "Close Window" button
    alert("You have just submitted your Research Study Application.\n\nPlease click [OK] to be redirected to the Research Study Applications page"); //encourage user to wait for redirect, user must click OK for the process to continue
	
	/*
	//447539 Refactor Workflow Rules Javascript Based On Web Service Research
	if (this.triggerIACUC) {
		saveToSPList(); 
	}*/
    //need to figure out how to send the current user as well
    //as how to grab the facility that the user is connected to.
	
    if(spAppData.AssignedIRBAdministratorId != null){
       insertStudyMember(sharepointIDtoSqlID(spAppData.AssignedIRBAdministratorId), "RAMS Reviewer", false, null);
    }
    /*
 	
 	//447539 Refactor Workflow Rules Javascript Based On Web Service Research
    var question1YesID, question1NoID, question2YesID, question2NoID, question3YesID, question3NoID, question4YesID, question4NoID;
	saveToSPList();
    */
    var PI = "";

    //*****only want to grab the pi if parent or local
    //if()

    appLink = {
        "__metadata": {"type": "SP.FieldUrlValue"},
        "Description": grabPI() + " - " + studyTitle + ": " + assignedID,
        "Url": window.location.href
    };

    if((spAppData.ApplicationSiteType == "Central") || ((currentFormType == "Parent") && (grabApplicationSiteType() == "Central"))){
        cirb = "Yes";
        getCentralUrl(function(returnedUrl, returnedFacilityId, returnedLiaisonId){
            insertStudyMember(sharepointIDtoTitle(returnedLiaisonId), "RAMS Reviewer", false, null);
            //console.log("in central, was given: " + returnedUrl + ", " + returnedFacilityId + ", " + returnedLiaisonId);
            subsiteUrl = returnedUrl;
        
            if(spAppData.CoordinatingSitesLiaisonId == null){
                liason = {"__metadata":{"type":"Collection(Edm.Int32)"},"results":[]};
            }else{
                liason = spAppData.CoordinatingSitesLiaisonId;
            }

            var data = {
                "__metadata": {"type": "SP.Data.ApplicationListItem"},
                "ApplicationStatus": "Submitted",
                "Study_ID": assignedID,
                "ParentStudyID": spAppData.ParentStudyID,
                "Title": studyTitle,
                "StudyTitle": studyTitle,
                "CIRB": cirb,
                "ApplicationSiteType": grabApplicationSiteType(),
                "CoordinatingSitesId": spAppData.CoordinatingSitesId, 
                "CoordinatingSitesLiaisonId": liason, 
                "ReviewRequired" : getReviewRequired(),
                "ReviewCompleted" : ""           
                }
                
                 //"ReviewRequired" : getReviewRequired(),
               // "ReviewCompleted" : getReviewRequired() 
            data[RAMS.Environment.SharePoint.List.Application.FacilityLookupId] = returnedFacilityId;
            data[RAMS.Environment.SharePoint.List.Application.PrincipalInvestigatorId] = currentUser.Id;
            data[RAMS.Environment.SharePoint.List.Application.LinkToApplication] = appLink;

            //console.log("the url we are using is: " + subsiteUrl + ", we are sending " + JSON.stringify(data));
            sendREST("POST", spAppData.__metadata.uri, data, function(){
                if(currentFormType == "Parent"){
                    sendREST("POST", siteUrl.concat(subsiteUrl.concat("_api/web/lists/getbytitle('Committee Topics')/items")), data, function(){
                        sendREST("POST", restPath.concat("study/"+assignedID+"/stage/Review"), null, function(){
                            window.location.assign("../SitePages/irb%20applications.aspx");
                        });
                    });                    
                }else{
                    sendREST("POST", /*siteUrl.concat(subsiteUrl.concat("_api/web/lists/getbytitle('Committee Topics')/items"))*/spsubsiteAppData.__metadata.uri, data, function(){
                        sendREST("POST", restPath.concat("study/"+assignedID+"/stage/Review"), null, function(){
                            window.location.assign("../SitePages/irb%20applications.aspx");
                        });
                    }, "Merge");                    
                }

            }, "Merge");
        });
    }else{
        cirb = "No";
        getSites(function(returnedUrl, returnedFacilityId, returnedLiaisonId){
            
		    //***For 1604 Release, as business requirement this code has to be excluded since users do not want default creation of RAMS Reviewer ***
			//Reversing this above decision  due to Liason name is not being recorded...thus throwin 404
			insertStudyMember(sharepointIDtoTitle(returnedLiaisonId), "RAMS Reviewer", true, null);
            //console.log("in regular, was given: " + returnedUrl + ", " + returnedFacilityId + ", " + returnedLiaisonId);
            subsiteUrl = returnedUrl;
			var currentUserFacility = returnedFacilityId;

            var data = {
                "__metadata": {"type": "SP.Data.ApplicationListItem"},
                "ApplicationStatus": "Submitted",
                "Study_ID": assignedID,
                "ParentStudyID": spAppData.ParentStudyID,
                "Title": studyTitle,
                "StudyTitle": studyTitle,
                "CIRB": cirb,
                "ApplicationSiteType": grabApplicationSiteType(),
                "ReviewRequired" : getReviewRequired(),
                "ReviewCompleted" : ""           
                }
                
           //The following condition will determine if the study is parent study or child study and will populate facilityID accordingly
			if (spAppData.ParticipatingSiteId !=null && spAppData.ParentStudyID != null ){
				
				data[RAMS.Environment.SharePoint.List.Application.FacilityLookupId] = spAppData.ParticipatingSiteId;
			}
			else{
				
				data[RAMS.Environment.SharePoint.List.Application.FacilityLookupId] = returnedFacilityId;

			}
            data[RAMS.Environment.SharePoint.List.Application.PrincipalInvestigatorId] = currentUser.Id;
            data[RAMS.Environment.SharePoint.List.Application.LinkToApplication] = appLink;

            sendREST("POST", spAppData.__metadata.uri, data, function(){
                if(currentFormType == "Parent"){
                    sendREST("POST", siteUrl.concat(subsiteUrl.concat("_api/web/lists/getbytitle('Committee Topics')/items")), data, function(){
                        sendREST("POST", restPath.concat("study/"+assignedID+"/stage/Review"), null, function(){
                            window.location.assign("../SitePages/irb%20applications.aspx");
                        });
                    });                    
                }else{
                    //sendREST("POST", siteUrl.concat(subsiteUrl.concat("_api/web/lists/getbytitle('Committee Topics')/items")), data, function(){
                    sendREST("POST", spsubsiteAppData.__metadata.uri, data, function(){
                        sendREST("POST", restPath.concat("study/"+assignedID+"/stage/Review"), null, function(){
                            window.location.assign("../SitePages/irb%20applications.aspx");
                        });
                    }, "Merge");                    
                }

            }, "Merge");            
        });
    }
};

//opens a new tab and starts the hipaa or icf download.
function generateHipaa(id){
    var xmlhttp;
    var sideButtons = $('.list-group-item.sectionLink');

    if(id == "15"){
        hipaaSection = sideButtons.length-1;
        window.open(restPath.concat("study/"+assignedID+"/documentGeneration/"+targetStage+"/"+hipaaSection));
    }else if(id == "14"){
        icfSection = sideButtons.length;
        window.open(restPath.concat("study/"+assignedID+"/documentGeneration/"+targetStage+"/"+icfSection));
    }
};


//puts together the content of the popup modal that allows users to see what files
//they've uploaded, delete uploaded files, what questions they have left to answer, allows 
//users to generate the hipaa and consent form, and submit the application.
function reviewApp(){
    var reviewCont, uploaded, fileTable, tableCont, fileHead, row, fileBody;
    determineIACUCApproval(); 
    //removing any trace of a previous popup modal
    $('#review').remove();

    //putting together the basic structure and style of the popup 
    reviewCont = document.createElement("div");
    reviewCont.setAttribute("id", "review");
    reviewCont.setAttribute("class", "well");
    reviewCont.setAttribute("style", "background: #fff");

    //getting all of the files
    // uploaded = sendREST("GET", restPath.concat("fascade/file/querystudy/" + assignedID), null, false);
    
    // var text = document.createTextNode("Below are all the files that you have uploaded:");
    // reviewCont.appendChild(text);
    
    // tableCont = document.createElement("div");
    // tableCont.setAttribute("class", "col-xs-12");

    // fileTable = document.createElement("table");
    // fileTable.setAttribute("class", "table table-bordered table-striped table-hover");

    // fileHead = document.createElement("thead");
    
    // row = document.createElement("tr");
    // row.appendChild(createCell("th", "File", null));
    // row.appendChild(createCell("th", "Remove", null));

    // fileHead.appendChild(row);
    // fileTable.appendChild(fileHead);

    // fileBody = document.createElement("tbody");
    
    // //putting together the table of files
    // if((uploaded.files === undefined)||(uploaded.files.length == 0)){
    //  row = document.createElement("tr");
    //  row.appendChild((createCell("td", "No Files Uploaded", null)));
    //  fileBody.appendChild(row);
    //  fileTable.appendChild(fileBody);
    // }else{
    //  for(var i=0; i<uploaded.files.length; i++){
    //      row = document.createElement("tr");
    //      row.setAttribute("name", uploaded.files[i].file);
    //      row.appendChild(createCell("td", uploaded.files[i].file, null));
    //      row.appendChild(createCell("td", "delete", uploaded.files[i].file, uploaded.files[i].details[0].tags));
    //      fileBody.appendChild(row);
    //  }
       // fileTable.appendChild(fileBody);
    // }
    // tableCont.appendChild(fileTable);
    // reviewCont.appendChild(tableCont);
    
    // var text = document.createTextNode("Review your application below:");
    // reviewCont.appendChild(text);

    //validate questions inserts the rest of the reviewing content
    reviewCont.appendChild(validateQuestions());

    var breaker = document.createElement("br");
    reviewCont.appendChild(breaker);

    //button to close the window
    var closer = document.createElement("button");
    closer.setAttribute("type", "button");
    closer.setAttribute("id", "closeWindow"); //add id to close window button
    closer.setAttribute("onclick", "Function($('#review').popup('toggle'))");
    //closer.setAttribute("onkeypress", "Function($('#review').popup('toggle'))");

    var text = document.createTextNode("Close Window");
    closer.appendChild(text);

    reviewCont.appendChild(closer);

    //specific library code to show popup
    $('body').append(reviewCont);
    $('#review').popup('show');
};

//creates a cell in a table. type is what kind of cell to create,
//content is what goes in the cell, tag is used to pass file
//information (since the only table is used with files)
function createCell(type, content, tag, id){
    
    var cell = document.createElement(type);
    
    var text = document.createTextNode(content);
    
    if(content == "delete"){
        //styling delete text
        var anchor = document.createElement("a");
        anchor.style.color = "blue";
        anchor.style.textDecoration = "underline";
        anchor.style.textDecorationColor = "blue";
        anchor.style.cursor = "pointer";
        
        anchor.appendChild(text);
        cell.appendChild(anchor);

        //tag here is used to link the remove button to a specific file
        cell.setAttribute("onclick", "removeFile('"+tag+"', "+id+")");
        //cell.setAttribute("onkeypress", "removeFile('"+tag+"', "+id+")");
    }else if(content == "No Files Uploaded"){
        cell.appendChild(text);
        cell.setAttribute("colspan", "2");
    }else{
        cell.appendChild(text);
    }
    
    return cell;
};

//rest call for removing a file from the cache and from
//the table
// function removeFile(file, id){
//     var status;
//     var qResponse = {};
//     var data = [];

//     status = sendREST("DELETE", restPath.concat("fascade/file/delete/study/"+assignedID+"/filename/"+file), null, false);
//     $('[name="'+file+'"]').remove();

//     response = {
//         "questionsID": id
//     };

//     data.push(response);

//     sendREST("POST", restPath.concat("study/"+assignedID+"/responses/"+targetStage), data, false);

// };

//assigning the appropriate icons to the buttons in the sidebar
function updateSidebarIcons(targetSection){
    //grabbing all of the section buttons
    var sideButtons;
    var incomplete=0;
    var complete=0;
    var empty=0;
    var total;

    if(assignedID == "1"){
        sideButtons = $('.list-group-item');
        //removing previous icons
        $('.glyphicon-adjust').remove();
        $('.glyphicon-record').remove();
        $('.glyphicon-ok-circle').remove();
        $('.glyphicon-ban-circle').remove();

        for(var i=0; i<sideButtons.length; i++){
            var icon = document.createElement("span");
            if(i == 0){
                icon.setAttribute("class", "glyphicon glyphicon-record");
            }else{
                icon.setAttribute("class", "glyphicon glyphicon-ban-circle");
                sideButtons[i].setAttribute("style", "cursor: not-allowed");
            }
            
            sideButtons[i].appendChild(icon);
            sideButtons[i].setAttribute("onclick", "insertWarning('You must complete Section A and Save your responses before proceeding.', 'alert-warning')");
            //sideButtons[i].setAttribute("onkeypress", "insertWarning('You must complete Section A and Save your responses before proceeding.', 'alert-warning')");
        }
    }else{
        validSection = [];
        sideButtons = $('.list-group-item.sectionLink');
        sendREST("GET", restPath.concat("study/"+assignedID+"/responses/"+targetStage+"/validation"), null, function(validationReport){
            //removing previous icons
            $('.glyphicon-adjust').remove();
            $('.glyphicon-record').remove();
            $('.glyphicon-ok-circle').remove();
            $('.glyphicon-ban-circle').remove();
            
            //going through the most recent user's responses and assigning them the correct icons as
            //well as giving the relevant buttons a link.
            for(var i=0; i<sideButtons.length; i++){
                var icon = document.createElement("span");
                if(validationReport.formStatusCollection[i].status == "INCOMPLETE"){
                    icon.setAttribute("class", "glyphicon glyphicon-adjust");
                    icon.setAttribute("alt", " has missing responses");
                    incomplete += 1;
                    sideButtons[i].setAttribute("onclick", "checkSave("+i+")");
                    //sideButtons[i].setAttribute("onkeypress", "checkSave("+i+")");
                    sideButtons[i].setAttribute("style", "cursor: pointer");
                }else if(validationReport.formStatusCollection[i].status == "NOT_APPLICABLE"){
                    //when a section isn't required a user shouldn't be able to click on it 
                    icon.setAttribute("class", "glyphicon glyphicon-ban-circle");
                    icon.setAttribute("alt", " is not applicable");
                    sideButtons[i].removeAttribute("onclick");
                    //sideButtons[i].removeAttribute("onkeypress");
                    sideButtons[i].setAttribute("style", "cursor: not-allowed");
                }else if(validationReport.formStatusCollection[i].status == "EMPTY"){
                    icon.setAttribute("class", "glyphicon glyphicon-record");
                    icon.setAttribute("alt", " has not been started");
                    sideButtons[i].setAttribute("onclick", "checkSave("+i+")");
                    //sideButtons[i].setAttribute("onkeypress", "checkSave("+i+")");
                    sideButtons[i].setAttribute("style", "cursor: pointer");
                    empty += 1;
                }else if(validationReport.formStatusCollection[i].status == "COMPLETE"){
                    icon.setAttribute("class", "glyphicon glyphicon-ok-circle");
                    icon.setAttribute("alt", " has been completed");
                    sideButtons[i].setAttribute("onclick", "checkSave("+i+")");
                    //sideButtons[i].setAttribute("onkeypress", "checkSave("+i+")");
                    sideButtons[i].setAttribute("style", "cursor: pointer");
                    complete += 1;
                    validSection.push(i);
                }
                sideButtons[i].appendChild(icon);
                sideButtons[i].setAttribute("rams-form-status", validationReport.formStatusCollection[i].status);
            }

            //updates the general information section that gives the user
            //a quick glance of how much they have left to do
            total = incomplete+empty+complete;
            $('.sectionLocation').html("Completed: " + complete + "/" + total);
        });
    }
};

function generateAssignedId(eventType, facilityID, liaisonID){
        //grabs a new generated study id
    if(eventType != null)
        parentID = assignedID;

    sendREST("GET", restPath.concat("fascade/studyidgenerator/sitecode/1111/humorani/H"), null, function(json){
        assignedID = json.studyAssignedID;

        ////console.log("in generate assigned id, sending: " + eventType + ", " + facilitiesID);
        createStudy(assignedID, eventType, facilityID, liaisonID);
    }); 
    
}

function grabApplicationType(){
    var applicationType = null;
    var exemptID, expeditedID, fullID;

    if(currentFormType == "Parent"){
        exemptID = study.containedFormCollection[0].containedForm.formQuestionCollection[5].question.answerCollection[0].answersID;
        expeditedID = study.containedFormCollection[0].containedForm.formQuestionCollection[5].question.answerCollection[1].answersID;
        fullID = study.containedFormCollection[0].containedForm.formQuestionCollection[5].question.answerCollection[2].answersID;
    
        if(rollupAnswers.contains(exemptID)){
            applicationType = "Exempt";
        }else if(rollupAnswers.contains(expeditedID)){
            applicationType = "Expedited";
        }else if(rollupAnswers.contains(fullID)){
            applicationType = "Full";
        }        
    }else{
        applicationType = spAppData.ApplicationType;
    }

    return applicationType;
}

function grabApplicationSiteType(){
    var applicationSiteType = null;
    var singleSiteID, multisiteID, centralID;

    if(currentFormType == "Parent"){
        singleSiteID = study.containedFormCollection[1].containedForm.formQuestionCollection[7].question.answerCollection[0].answersID;
        multisiteID = study.containedFormCollection[1].containedForm.formQuestionCollection[8].question.answerCollection[0].answersID;
        centralID = study.containedFormCollection[1].containedForm.formQuestionCollection[9].question.answerCollection[0].answersID;
    
        if(rollupAnswers.contains(singleSiteID)){
            applicationSiteType = "Local";
        }else if(rollupAnswers.contains(multisiteID)){
            applicationSiteType = "Multi";
        }else if(rollupAnswers.contains(centralID)){
            applicationSiteType = "Central";
        }

    }else{
        applicationSiteType = spAppData.ApplicationSiteType;
    }

    return applicationSiteType;
}

function grabPI(){
    var pid; 
    var currentPI = null;

    if(currentFormType == "Parent"){
        pid = study.containedFormCollection[0].containedForm.formQuestionCollection[1].question.questionsID;
    }else if(currentFormType == "Local"){
        pid = study.containedFormCollection[0].containedForm.formQuestionCollection[0].question.questionsID;
    }

    if($('[name="QID_'+pid+'"]').val() != null){
        currentPI = $('[name="QID_'+pid+'"]').val();
    }else{
        for(var i=0; i<rollup.responses.length; i++){
            if(rollup.responses && (rollup.responses[i].questionsID == pid)){
                currentPI = rollup.responses[i].response;
            }
        }
    }

    return currentPI;
}

function grabCoPI(){
    var copid;
    var currentCoPI = null;

    if(currentFormType == "Parent"){
        copid = study.containedFormCollection[0].containedForm.formQuestionCollection[3].question.questionsID;
    }else if(currentFormType == "Local"){
        copid = study.containedFormCollection[0].containedForm.formQuestionCollection[8].question.questionsID;
    }
    

    if(rollup.responses === undefined){
        currentCoPI = $('[name="QID_'+copid+'"]').val();
    }else{       
        for(var i=0; i<rollup.responses.length; i++){
            if(rollup.responses[i].questionsID == copid){
                currentCoPI = rollup.responses[i].response;
            }
        }
    }



    //once we have the login
    //get
    //_api/SP.UserProfiles.PeopleManager/GetPropertiesFor(accountName=@v)?@v='vhamaster\vhaiswjogiak'

    return currentCoPI;
}

function sharepointIDtoSqlID(spUserID){
    var userID = null;

    for(var j=0; j<sqlUsers.length; j++){
        //if(spUserID == userIDMap.get(sqlUsers[j].SPUser)){
        if((sqlUsers[j].SPUser !== undefined) && (spUserID == userIDMap.get(sqlUsers[j].SPUser))){    
            //console.log("we've found the user: " + sqlUsers[j].displayName + " with ID " + sqlUsers[j].usersID);
            userID = sqlUsers[j].usersID;
        }
    }
    
    return userID;
}

function sharepointIDtoTitle(spUserID){
    var tempUsers = ramsUsers.values();

    for(var i=0; i<tempUsers.length; i++){
        if(tempUsers[i].Id == spUserID){
            ////console.log("found User: " + tempUsers[i].Title);
            return tempUsers[i].Title;
        }
    }

    return null;
};

function titleToSharepointID(spUserTitle){
    var tempUsers = ramsUsers.values();

    for(var i=0; i<tempUsers.length; i++){
        if(tempUsers[i].Title == spUserTitle){
            return tempUsers[i].Id;
        }
    }

    return null;
};

function createStudy(assignedID, eventType, facilityID, liaisonID){
    var id, titleID, packaging, data;
    // var userTable = new Hashtable();

    var facility;
    var studyMembersCollection = [{
    	"user": sqlUsers,
    	"coiRequired": false,
    	"writePermissions": true,
    	"explaination": "Initiated this study application.",
    	"notifications": true,
    	"teamMember": true,
    	"activeMember": true,
    	"createdAt": new Date().toJSON()
    }];
    if (grabPI() == currentUser.Title)
        studyMembersCollection[0].memberRole = "Principal Investigator";
    else if (grabCoPI() == currentUser.Title)
        studyMembersCollection[0].memberRole = "Co-Principal Investigator";
	else
		studyMembersCollection[0].memberRole = "Study Member";
	

    function createStudyItself() {
        //we know we are only creating the study when we are on the first page, grabbing the study title

        if(studyTitle == ""){
            titleID = study.containedFormCollection[0].containedForm.formQuestionCollection[0].question.questionsID;
            studyTitle = $("[name = 'QID_"+titleID+"']").val(); 
        }

        packaging = {
            "assignedID": assignedID,
            "facility": facility,
            "title": studyTitle,
            "studyMembersCollection": studyMembersCollection
        }

        var data = {
            "__metadata": {"type": "SP.Data.ApplicationListItem"},
            "Study_ID": assignedID,
            "Title": studyTitle,
            "StudyTitle": studyTitle,
            "ApplicationStatus": "Draft"
        }
        data[RAMS.Environment.SharePoint.List.Application.PrincipalInvestigatorId] = titleToSharepointID(grabPI());
        data[RAMS.Environment.SharePoint.List.Application.CoPrincipalInvestigatorId] = titleToSharepointID(grabCoPI());
        //putting the application in SP
        sendREST("POST", siteUrl.concat("_api/web/lists/getbytitle('Application')/items"), data, function(){
            //sendREST("POST", siteUrl.concat(subCommittee.concat("_api/web/lists/getbytitle('Committee Topics')/items")), data, function(){
                //putting the newly created study in the database
                sendREST("POST", restPath.concat("study/formVersionsID/"+currentFormVersion), packaging, function(studyResponse){
                    targetStage = studyResponse.studyStatusCollection.length;
                    targetState = studyResponse.studyStatusCollection[targetStage - 1].studyState.studyStatesID;
                    insertStudyMember(grabPI(), "Principal Investigator", true, null); //add PI to study member list
                    insertStudyMember(grabCoPI(), "Co-Principal Investigator", true, null); //add CoPI to study member list
                    var headerArea = $('div.page-header');
					headerArea.empty();
                    headerBuilder(0, headerArea);
					sendResponses();
                });
            //});
        });
        
    }


   function createChildStudy(eventType, facilityID, liaisonID){
        var appendingString, childFormVersion, cirb, subsiteUrl, currentFacility, appType, appLink;
		
        if(eventType == "Local"){
            appendingString = " - Local Site Application";
            childFormVersion = currentFormVersion+1;
            appType = spAppData.ApplicationSiteType;
            currentFacility = facilityID;
        }

        if(eventType == "Adverse"){
            appendingString = " - Adverse/Reportable Event";
            childFormVersion = currentFormVersion+2;
            appType = "Adverse/Reportable Event";
            currentFacility = spAppData[RAMS.Environment.SharePoint.List.Application.FacilityLookupId];
        }

        if(eventType == "ContReview"){
            appendingString = " - Continuing Review";
            childFormVersion = currentFormVersion+3;
            appType = "Renewal";
            currentFacility = spAppData[RAMS.Environment.SharePoint.List.Application.FacilityLookupId];
        }

        if(eventType == "Closeout"){
            appendingString = " - Closeout";
            childFormVersion = currentFormVersion+4;
            appType = "Closeout";
            currentFacility = spAppData[RAMS.Environment.SharePoint.List.Application.FacilityLookupId];
        }

        if(eventType == "AdministrativeUpdate"){
            appendingString = " - Administrative Update";
            childFormVersion = currentFormVersion+5;
            appType = "Administrative Update";
            currentFacility = spAppData[RAMS.Environment.SharePoint.List.Application.FacilityLookupId];
        }

        //grab assignedIRB Admin and add them to packaging
        //if anything but local, add the current PI as well.
        if(facilityID != null){
            currentFacility = facilityID;
        }else{
            currentFacility = spAppData[RAMS.Environment.SharePoint.List.Application.FacilityLookupId];
        }

        appLink = {
            "__metadata": {"type": "SP.FieldUrlValue"},
            "Description": studyTitle + ": " + assignedID,
            "Url": "/SiteAssets/irb-applications-general.html?" + assignedID
        };


        packaging = {
            "assignedID": assignedID,
            "facility": facility,
            "title": studyTitle + appendingString,
            "studyMembersCollection": studyMembersCollection
        };
        
        //Static values
        var mainData = {
            "__metadata": {"type": "SP.Data.ApplicationListItem"},
            "Study_ID": assignedID,
            "Title": studyTitle + appendingString,
            "StudyTitle": studyTitle + appendingString,
            "ParentStudyID": parentID,
            "AssignedIRBAdministratorId": spAppData.AssignedIRBAdministratorId,
            "CIRB": spAppData.CIRB,
            "ApplicationType": appType,
            "ApplicationSiteType": spAppData.ApplicationSiteType,
            "ApplicationStatus": "Draft",
            "ParticipatingSiteApplicationStat": "Draft",
            "ReviewersId": {'results': [liaisonID]}
        };

        //Dynamic values (read in from config file)
        mainData[RAMS.Environment.SharePoint.List.Application.FacilityLookupId] = currentFacility;
        mainData[RAMS.Environment.SharePoint.List.Application.LinkToApplication] = appLink;
        mainData[RAMS.Environment.SharePoint.List.Application.PrincipalInvestigatorId] = spAppData.PrincipalInvestigatorId;
	    
        //console.log("event type " + eventType + ", " + childFormVersion);
        sendREST("GET", siteUrl + "_api/Web/Lists/GetByTitle('Application')/Items" + "?$filter=ParentStudyID eq '" + parentID + "'" , null, function(json) {
        	var temp = json.d.results;
        	for(var i=0; i<temp.length; i++){
				//alert('temp index is  '+ i);
        		if (temp[i].ParticipatingSiteId == currentFacility){
					//alert (temp[i].ParticipatingSiteId + ' eq' + currentFacility);
					sendREST("POST", temp[i].__metadata.uri, mainData, function(){
						sendREST("GET", siteUrl.concat("_api/web/lists/getbytitle('Facility')/items("+currentFacility+")"), null, function(returnedFacilityjson){
							            var tempFacility = returnedFacilityjson;
							            var facilityUrl = tempFacility.d.Facility_x0020_Subsite.Url;
        				     			sendREST("POST", facilityUrl.concat("/_api/web/lists/getbytitle('Committee Topics')/items"), mainData, function(){
        				        			sendREST("POST", restPath.concat("study/formVersionsID/"+childFormVersion), packaging, function(studyResponse){
        				        				sendREST("POST", restPath.concat("study/"+assignedID+"/parentstudy/"+parentID), null, function(json){
        				        					//window.location.assign("irb-applications-general.html?") + assignedID;
													//refreshDisplay('Facility');
													insertStudyMember(sharepointIDtoTitle(liaisonID), "RAMS Reviewer", true, null);

													window.location.assign("../SitePages/irb%20applications.aspx");
        				        				});
        				        			});
        				  			});
						});
					},"Merge");
        		}
        	}
        	;
        });
    }

    sendREST("GET", siteUrl.concat("_api/web/lists/getbytitle('Facility')/items"), null, function(facilities){

        facility = {
            // "administratorSPGroup": 0,
            // "description": currentFacility.Title,
            // "facilitiesID": currentFacility.ID,
            // "name": currentFacility.Facility_Name,
            // "reviewerSPCalendar": "00000000-0000-0000-0000-000000000000",
            // "reviewerSPGroup": 0,
            // "safetySPGroup": 0

            "administratorSPGroup": 0,
            "description": "initial facility",
            "facilitiesID": 0,
            "name": "General Site",
            "reviewerSPCalendar": "00000000-0000-0000-0000-000000000000",
            "reviewerSPGroup": 0,
            "safetySPGroup": 0
        };
        if(eventType != null){
            ////console.log("in create study, sending " + eventType + ", " + facilityID);
            createChildStudy(eventType, facilityID, liaisonID);
        }else{
            createStudyItself();
        }
        
    });
};//end of CreateStudy


function insertStudyMember(userTitle, role, teamMember, afterward) {
    var foundUser = false;

    //grab user id from sql 
    //console.log("we want to add " + userTitle + " as a " + role);

    sendREST("GET", restPath.concat("study/"+assignedID+"/members"), null, function(returnedMembers){
        
        for(var i=0; i<returnedMembers.length; i++){
            if(returnedMembers[i].user.displayName == userTitle){
                foundUser = true;
            }
        }
        
        

        if(!foundUser){
            sendREST("GET", restPath.concat("user"), null, function(returnedUsers){
                for(var j=0; j<returnedUsers.length; j++){
                    if(returnedUsers[j].displayName == userTitle ){  

                        //console.log("found user: " + userTitle + ", " + returnedUsers[j].usersID);

                        if(grabPI() == userTitle){
                            role = "Principal Investigator";
                        }else if(grabCoPI() == userTitle){
                            role = "Co-Principal Investigator";
                        }

                        var data = {
                            "user": returnedUsers[j],
                            "activeMember": true,
                            "vaUser": true,
                            "teamMember": teamMember,
                            "memberRole": role,
                            "coiRequired": false,
                            "writePermissions": true,
                            "explaination": "n/a",
                            "notifications": true                    
                        }
                        
                        sendREST("POST", restPath.concat("study/"+assignedID+"/members"), data, function(){
							
							console.log("to this study, we want to add member: " + JSON.stringify(returnedUsers[j]));
						});
						
                    }
                }
            });   
        }
    }); 
}

function testinsertStudyMember(userTitle, role, teamMember, afterward) {
    var foundUser = false;

    //grab user id from sql 
    console.log("we want to add " + userTitle + " as a " + role);

   
		console.log("User not found, so insert");
            sendREST("GET", restPath.concat("user"), null, function(returnedUsers){
                for(var j=0; j<returnedUsers.length; j++){
                    if(returnedUsers[j].displayName == userTitle ){  
			console.log("found user: " + userTitle + ", " + returnedUsers[j].usersID);

			role = "Co-Principal Investigator";
			console.log("role:"+role);
                        var data = {
                            "user": returnedUsers[j],
                            "activeMember": true,
                            "vaUser": true,
                            "teamMember": teamMember,
                            "memberRole": role,
                            "coiRequired": false,
                            "writePermissions": true,
                            "explaination": "n/a",
                            "notifications": true                    
                        }
                        console.log("from here, we want to add: " + JSON.stringify(returnedUsers[j]));
                        sendREST("POST", restPath.concat("study/"+assignedID+"/members"), data, afterward);
                    }
                }
            });   

}

function initialSectionCheck(){
    var section, required, question;
    var questionCollection = new HashSet();

    section = study.containedFormCollection[0].containedForm.formQuestionCollection; 

    for(var i=0; i<section.length; i++){
        required = true;

        //grabbing a specific question
        question = section[i].question.questionsID;

        if(section[i].requiredPredecessorAnswersID){
            //here we are looking into first level dependent questions. With the current 
            //section A, there isn't a question dependency where question C depends on question
            //B which depends on question A (second level dependency);
            var parent = section[i].requiredPredecessorAnswersID; 

            if(($("#"+parent).is(':checked')) == false){
                required = false; 
            }
        }

        if(required){
            if((section[i].question.responseFormat.name == "radio") || (section[i].question.responseFormat.name == "checkbox")){
                var complete = false;
                var answers = $('[name="QID_'+question+'_multi"]');

                for(var j=0; j<answers.length; j++){
                    var id = answers[j].getAttribute("id");

                    if($("#"+id).is(':checked')){
                        complete = true;
                    }
                }

                if(complete != true){
                    return false;
                }

            }else if(section[i].question.responseFormat.name == "select"){
                if($("[name = '"+question+"']").find(':selected').val() == "none"){
                    return false;
                }

            }else{
                if($("[name = '"+question+"']").val() == ""){
                    return false;
                }
            }
        }
    }
    return true;
}

//grabbing all user input and packaging it up to send to the database
function createResponses(){
    if(assignedID == "1"){
        if(initialSectionCheck() == false){
            insertWarning('You must complete Section A and save your responses before proceeding.', 'alert-warning');

            return;
        }else{
            generateAssignedId(null);
        }
    }else{
        sendResponses();
    }
}

/*Reenables the save progress button if a question response
has been changed on the current application section*/
function checkEnableSaveButton(questionsID){
	changedQuestions.add(questionsID);
	
	if (!changedQuestions.isEmpty()){
		$("#saveAppProgress").prop("disabled", false); //reenable save progress button
	}
}





function triggerUploadModal(){
	
	var modal, modalDialog, modalContent, modalHeader;
	var header, heading1, lineBreak, saveButton, closeButton, text, modalTitle, modalBody, modalFooter;
	var container, tableHeader, table, tableDiv, tbody, trow, trow2, dateAdded, cell;
	var statusTypes = ["Approved", "Changes Requested", "Submitted", "Under Review"];
	var documentTypes = ["Audit", "Case Report Forms", "COIs", "CVs", "Device Information", "HIPAA", "ICF", "Investigator Brochure/Package Insert", "Letters/Correspondence", "Protocol", "Questionnaires/Surveys", "Recruitment Material", "VA Form 10-9012", "Waiver Requests", "Other"];
	
	modal = document.createElement("div");
	modal.setAttribute("class", "modal");
	modal.setAttribute("id", "uploadModal");
	modal.setAttribute("tabindex", "-1");
	modal.setAttribute("role", "dialog");
	modal.setAttribute("aria-labelledby", "uploadModal");
	
	modalDialog = document.createElement("div");
	modalDialog.setAttribute("role", "document");
	
	modalContent = document.createElement("div");
	modalContent.setAttribute("class", "modal-content");
	modalHeader = document.createElement("div");
	modalHeader.setAttribute("class", "modal-header");
	modalHeader.setAttribute("tabindex", "0"); //start tabbing on modal from header
	
	header = document.createElement("header");
	header.setAttribute("class", "modal-title");
	header.setAttribute("id", "modalTitle");
	
	heading1 = document.createElement("H2");
	heading1.setAttribute("class", "modal-title");
	text = document.createTextNode("Upload Document");
	heading1.appendChild(text);
	header.appendChild(heading1);
	modalHeader.appendChild(header);
	
	modalContent.appendChild(modalHeader);
	lineBreak = document.createElement("br");
	text = document.createTextNode("To successfully upload your document, select your document type, click Browse to select your document and click the Save Document button. Then close the window to return to the application.");
//	text.setAttribute("tabindex", "1");
	
	modalContent.appendChild(modalHeader);
	modalContent.appendChild(lineBreak);
	modalContent.appendChild(text);
	modalContent.appendChild(lineBreak);
	
	/*Build Table for Uploading Document*/
    container = document.createElement("div");
    container.setAttribute("class", "form-content");
    
    /*Table Header/Division*/
//    tableHeader = tableHeaderHelper("Complete the sections below: ", ["Status", "Date Approved", "Document Type", "Upload Document"]);
    tableDiv = document.createElement("div");
    tableDiv.setAttribute("class", "div-table-content-big"); //div-table-content-big should be small?
    
    /*Table Style*/
    table = document.createElement("table");
    table.setAttribute("class", "table table-striped table-hover");
    table.setAttribute("tabindex", "0");

    /*Table Body & Rows*/
    tbody = document.createElement("tbody");
    trow = document.createElement("tr");
    trow.setAttribute("tabindex", "0");
    trow2 = document.createElement("tr");
    
    trow.appendChild(buildSelecterHelper("docType", "Document Type", documentTypes, 12));
    trow2.appendChild(fileSelectorBuilder("uploadDoc", "Upload Document:"));
//  trow2.appendChild(buildSelecterHelper("docStatus", "Status", statusTypes, 12));

    /*Add Table Elements Together*/
    tbody.appendChild(trow);
    tbody.appendChild(trow2);
	table.appendChild(tbody);
	tableDiv.appendChild(table);
//	container.appendChild(tableHeader); //took out
	container.appendChild(tableDiv);
	container.appendChild(lineBreak);
	
	modalFooter = document.createElement("div");
	modalFooter.setAttribute("class", "modal-footer");
	
	/*Add Save Document Button*/
	saveButton = document.createElement("button");
	saveButton.setAttribute("class", "btn btn-sm modal-button");
	saveButton.setAttribute("aria-label", "Save");
	
	saveButton.setAttribute("title", "Save your document"); //hover tip
	saveButton.setAttribute("type", "button");
	saveButton.setAttribute("role", "button");
	saveButton.setAttribute("id", "saveModal");
	
	saveButton.setAttribute("onclick", "saveAttachment()");
	text = document.createTextNode("Save Document");
	saveButton.appendChild(text);
	
	/*Add Close Window Button*/
	closeButton = document.createElement("button");
	closeButton.setAttribute("class", "btn btn-sm modal-button modal-button-right");
	closeButton.setAttribute("data-dismiss", "modal");
	closeButton.setAttribute("aria-label", "Close");
	
	closeButton.setAttribute("title", "Close this window and return to the application"); //hover tip
	closeButton.setAttribute("type", "button");
	closeButton.setAttribute("role", "button");
	closeButton.setAttribute("id", "closeModal");
	
	closeButton.setAttribute("onclick", "$('#uploadModal').popup('toggle')");
	text = document.createTextNode("Close this window");
	closeButton.appendChild(text);
	
	/*Combine Modal Elements*/
	modalContent.appendChild(container);
	modalFooter.appendChild(saveButton);
	modalFooter.appendChild(closeButton);
	modalContent.appendChild(modalFooter);
	modalDialog.appendChild(modalContent);
	modal.appendChild(modalDialog);
	$('body').append(modal);
	$('#uploadModal').popup('show');
	
}

function saveAttachment(){
	
	var documentType = $('#docType').find(':selected').val(); 

		uploadFiles(documentType);
		
}

function uploadFiles(documentType){
    var fileList, targetSection;
    var data = [];
    var response = {};
    var uploaders;
    
    //looking for uploaded files to send to the cache
    uploaders = $('[type="file"]');
    for(var i=0; i<uploaders.length; i++){
        if(uploaders[i].value){
            if(window.FileReader != null){
                fileList = uploaders[i].files;

                for(var j=0; j<fileList.length; j++){
                    //console.log("uploading: " + uploaders[i].name.replace('QID_', '') + "-RAMS-" +fileList[j].name);

                    //sendFile(fileList[j], uploaders[i].name.replace('QID_', '') + "-RAMS-" +fileList[j].name, fileList[j].size, "Study%20Team", documentType, function(){
					sendFile(fileList[j], fileList[j].name, fileList[j].size, "Study%20Team", documentType, function(){
                        var sidebar = $('.list-group-item.sectionLink');
                        var current = $('.list-group-item.active');
                        for(var i=0; i<sidebar.length; i++){
                            if(sidebar.get(i) == current.get(0)){
                                targetSection = i;
                                //updating sidebar icons now that we have the section that
                                //should show up as activated.
                                sendREST("GET", siteUrl.concat("_api/web/GetFolderByServerRelativeUrl('Shared%20Documents/"+assignedID+"/Study%20Team')/Files"), null, function(returnedFiles){
                                    attachments = returnedFiles.d.results;                                
                                    wellSidebarBuilder(targetSection, attachments.length);
                                });
                            }     
                        }
                    });
                }
                
                response = {
                    "questionsID": (uploaders[i].name).replace('QID_', ''),
                    "response": fileList[0].name
                }
                data.push(response);
                sendREST("POST", restPath.concat("study/"+assignedID+"/responses/"+targetStage), data); //record data associated with upload
            }else{
                alert('Please upgrade your browser to upload files.');
                i = uploaders.length;
            }
        }
    }
    
}
function uploadHipaa(){
	
	var fileList, targetSection;
    var data = [];
    var response = {};
    var uploaders;

    //looking for uploaded files to send to the cache
    uploaders = $('[type="file"]');
    for(var i=0; i<uploaders.length; i++){
        if(uploaders[i].value){
            if(window.FileReader != null){
                fileList = uploaders[i].files;

                for(var j=0; j<fileList.length; j++){
                    //console.log("uploading: " + uploaders[i].name.replace('QID_', '') + "-RAMS-" +fileList[j].name);

                    sendHipaaFile(fileList[j], fileList[j].name, fileList[j].size, "Study%20Team");
                }
                /*
                response = {
                    "questionsID": (uploaders[i].name).replace('QID_', ''),
                    "response": fileList[0].name
                }
                data.push(response);
                sendREST("POST", restPath.concat("study/"+assignedID+"/responses/"+targetStage), data); //record data associated with upload
				*/
            }else{
                alert('Please upgrade your browser to upload files.');
                i = uploaders.length;
            }
        }
    }
}
/*
function sendFile(file, fileName, fileSize, teamFolder, callback){
    var reader = new FileReader();

    reader.onloadend = function(evt){
        if(evt.target.readyState == FileReader.DONE){
            jQuery.ajax({
                url: siteUrl.concat("_api/web/GetFolderByServerRelativeUrl('Shared%20Documents/"+assignedID+"/"+teamFolder+"')/Files/add(url='"+fileName+"',overwrite=true)"),
                type: "POST", 
                data: evt.target.result,
                processData: false,
                headers: {
                    "accept": "application/json; odata=verbose",
                    "X-RequestDigest": requestDigest,
                    "content-length": fileSize
                }
            }).done(function(){
                insertWarning('You have successfully uploaded your document(s)', 'alert-success');
                refreshDisplay('Files'); //go to 'Attachments' page
                if(callback){
                    callback();
                }           
            });       
        }
    }

    reader.readAsArrayBuffer(file);
}
*/

//This function will assign the study to multiple sites
//function assignMultiSiteStudy(localSite, localSiteInvestigator){
//	var siteArray; //placeholder
//	alert("Sites involved - " + siteArray.length);
//}

 
function sendFile(file, fileName, fileSize, teamFolder, documentType, callback){
    var reader = new FileReader();

    reader.onloadend = function(evt){
        if(evt.target.readyState == FileReader.DONE){
			var test = siteUrl.concat("_api/web/GetFolderByServerRelativeUrl('Shared%20Documents/"+assignedID+"/"+teamFolder+"')/Files/add(url='"+fileName+"',overwrite=true)");
            jQuery.ajax({
                url: siteUrl.concat("_api/web/GetFolderByServerRelativeUrl('Shared%20Documents/"+assignedID+"/"+teamFolder+"')/Files/add(url='"+fileName+"',overwrite=true)"),
                type: "POST", 
                data: evt.target.result,
                processData: false,
                headers: {
                    "accept": "application/json; odata=verbose",
                    "X-RequestDigest": requestDigest,
                    "content-length": fileSize
                }
            }).done(function(file, status, xhr){
				
					// Get the list item that corresponds to the uploaded file.
					var getItem = getListItem(file.d.ListItemAllFields.__deferred.uri);
					getItem.done(function (listItem, status, xhr) {

						// Change the display name and title of the list item.
						var changeItem = updateListItem(listItem.d.__metadata, documentType);
						changeItem.done(function (data, status, xhr) {
							alert('file uploaded and updated');
						});
						changeItem.fail(onError);
					});
					getItem.fail(onError);
				
				insertWarning('You have successfully uploaded your document(s)', 'alert-success');
                refreshDisplay('Files'); //go to 'Attachments' page
                if(callback){
                    callback();
                }   
             }).fail(function (jqXHR, textStatus) {
					alert("jqXHR.status=" + jqXHR.status);
				         
			});       
        }
    }
	
	reader.readAsArrayBuffer(file);
}

// Display error messages. 
function onError(error) {
    alert(error.responseText);
}

function updateListItem(itemMetadata, documentType) {

        // Define the list item changes. Use the FileLeafRef property to change the display name. 
        // For simplicity, also use the name as the title. 
        // The example gets the list item type from the item's metadata, but you can also get it from the
        // ListItemEntityTypeFullName property of the list.
        
		var item = {
		"__metadata": {"type": itemMetadata.type},
		"DocumentType": documentType
		};


        // Send the request and return the promise.
        // This call does not return response content from the server.
        return jQuery.ajax({
            url: itemMetadata.uri,
            type: "POST",
            data: JSON.stringify(item),
            headers: {
                "X-RequestDigest": requestDigest,
                "content-type": "application/json;odata=verbose",
                "IF-MATCH": itemMetadata.etag,
                "X-HTTP-Method": "MERGE"
            }
        });
}
// Get the list item that corresponds to the file by calling the file's ListItemAllFields property.
 function getListItem(fileListItemUri) {

        // Send the request and return the response.
        return jQuery.ajax({
            url: fileListItemUri,
            type: "GET",
            headers: { "accept": "application/json;odata=verbose" }
        });
}



function sendResponses(){
    var changedPackage, fileList, reader, targetSection; 
    var qResponse = {};
    var data = [];
    var response = {};
    var question, uploaders;

    //looking for uploaded files to send to the cache
    uploaders = $('[type="file"]');
    for(var i=0; i<uploaders.length; i++){
        if(uploaders[i].value){
            if(window.FileReader != null){
                fileList = uploaders[i].files;

                for(var j=0; j<fileList.length; j++){
                    //console.log("uploading: " + uploaders[i].name.replace('QID_', '') + "-RAMS-" +fileList[j].name);

                    sendFile(fileList[j], uploaders[i].name.replace('QID_', '') + "-RAMS-" +fileList[j].name, fileList[j].size, "Study%20Team", function(){
                        var sidebar = $('.list-group-item.sectionLink');
                        var current = $('.list-group-item.active');
                        for(var i=0; i<sidebar.length; i++){
                            if(sidebar.get(i) == current.get(0)){
                                targetSection = i;
                                //updating sidebar icons now that we have the section that
                                //should show up as activated.
                                sendREST("GET", siteUrl.concat("_api/web/GetFolderByServerRelativeUrl('Shared%20Documents/"+assignedID+"/Study%20Team')/Files"), null, function(returnedFiles){
                                    attachments = filterChecklists(returnedFiles.d.results, "-RAMS-");                                
                                    wellSidebarBuilder(targetSection, attachments.length);
                                });
                            }     
                        }
                    });
                }

                response = {
                    "questionsID": (uploaders[i].name).replace('QID_', ''),
                    "response": fileList[0].name
                }
                data.push(response);

                if(changedQuestions.contains(parseInt((uploaders[i].name).replace('QID_', '')))){
                    changedQuestions.remove(parseInt((uploaders[i].name).replace('QID_', '')));
                }
            }else{
                alert('Please upgrade your browser to upload files.');
                i = uploaders.length;
            }
        }
    }

    //updating the study title in the database
    if((window.location.href.split("?")[1] != "1") && (currentFormType == "Parent") && (changedQuestions.contains(study.containedFormCollection[0].containedForm.formQuestionCollection[0].question.questionsID))){
        var studyTitleID = study.containedFormCollection[0].containedForm.formQuestionCollection[0].question.questionsID;

        studyTitle = $('[name="QID_'+studyTitleID+'"]').val();

        var studyPackage = {
            "title": studyTitle
        };

        var spdata = {
            "__metadata": spAppData.__metadata,
            "Title": studyTitle,
            "StudyTitle": studyTitle
        }

        sendREST("POST", spAppData.__metadata.uri, spdata, function(){
			var headerArea = $('div.page-header'), updateStudyInService = function() {
				sendREST("POST", restPath + "study/" + assignedID, studyPackage, function() {
					headerArea.empty();
					headerBuilder(0, headerArea);
				});
			};
            if(targetStage != 1){
                sendREST("POST", spsubsiteAppData.__metadata.uri, spdata, updateStudyInService, "Merge");
            }else{            
				updateStudyInService();
            }
        }, "Merge");
    }

    //updating the PI in the database
    if((window.location.href.split("?")[1] != "1") && (currentFormType == "Parent") && (changedQuestions.contains(study.containedFormCollection[0].containedForm.formQuestionCollection[1].question.questionsID))){
        var spData = {
            "__metadata": spAppData.__metadata
        };
        spData[RAMS.Environment.SharePoint.List.Application.PrincipalInvestigatorId] = titleToSharepointID(grabPI());

    //insertStudyMember(grabPI(), "Principal Investigator", true);

        sendREST("POST", spAppData.__metadata.uri, spData, function(){
            if(targetStage != 1){
                sendREST("POST", spsubsiteAppData.__metadata.uri, spData)
            }
        }, "Merge");
    }

    //changed questions keeps track of what questions the user
    //has modified while filling out the current section. we only
    //want to package up and send these questions
    changedPackage = changedQuestions.values();
    changedQuestions = new HashSet();
    
    //Filtering through each changed question and packaging it up based on what
    //type of input it is.
    for(var i=0; i<changedPackage.length; i++){
        //var toPackage = $('[name="QID_'+changedPackage[i]+'"], #AID_'+changedPackage[i]+'');
        var toPackage = $('[name="QID_'+changedPackage[i]+'"], [name="QID_'+changedPackage[i]+'_multi"]');
        for(var j=0; j<toPackage.length; j++){
            if((toPackage[j].type == "radio")) {
                    //have to grab the set of radios assigned to a questions and see 
                    //which one is actually selected to send to the database
                if(toPackage[j].checked == true){
                    response = {
                    "answersID": (toPackage[j].id).replace('AID_', ''),
                    "questionsID": (toPackage[j].name).replace('QID_', '').replace('_multi', '')
                    };
                    data.push(response);
                }
            }else if((toPackage[j].type == "checkbox")){
                //there's a difference in how checked checkboxes
                //are sent vs how unchecked checkboxes are sent
                if(toPackage[j].checked == true){
                    response = {
                        "answersID": (toPackage[j].id).replace('AID_', ''),
                        "checkboxIndex": toPackage[j].title,
                        "questionsID": (toPackage[j].name).replace('QID_', '').replace('_multi', '')
                    };
                data.push(response);
                }else if(toPackage[j].checked == false){
                    response = {
                        "checkboxIndex": toPackage[j].title,
                        "questionsID": (toPackage[j].name).replace('QID_', '').replace('_multi', '')
                    };
                data.push(response);
                }
            }else if((toPackage[j].type == "text") || (toPackage[j].type == "textarea") || (toPackage[j].type == "select-one")){
                    //everything else is pretty straightforward to send
                    response = {
                    "questionsID": (toPackage[j].name).replace('QID_', ''),
                    "response": toPackage[j].value
                    };
                data.push(response);
            }
        } 
    }

    if(data.length == 0){
        insertWarning("There are no modified responses to be saved.", "alert-warning");
    }else{
        sendREST("POST", restPath.concat("study/"+assignedID+"/responses/"+targetStage), data, function(){
            //indicates that the application is out of sync
            if(window.location.href.split("?")[1] == "1"){
                window.location.assign("../SiteAssets/irb-applications-general.html?"+assignedID);
                //alert('kishore, you commented out 2727');
            }
            sendREST("GET", restPath.concat("study/"+assignedID+"/responses/"+targetStage+"/rollup"), null, function(json){
                rollup = json;
                rollupAnswers = new HashSet();
                rollupQuestions = new HashSet();

                for(var j=0; j<rollup.responses.length; j++){
                    //adding selected radios and checkboxes
                    if(rollup.responses[j].answersID !== undefined){
                        rollupAnswers.add(rollup.responses[j].answersID);
                    }
                    //adding questions regardless
                    rollupQuestions.add(rollup.responses[j].questionsID);
                }

                //getting current target section to pass 
                // //console.log("the amount of data");
                // if(data.length > 0){
                    var sidebar = $('.list-group-item.sectionLink');
                    var current = $('.list-group-item.active');
                    for(var i=0; i<sidebar.length; i++){
                        //if(sidebar.get(i) == current.get(0)){
                        if(sidebar[i] == current[0]){
                            targetSection = i;
                            //updating sidebar icons now that we have the section that
                            //should show up as activated.
                            //updateSidebarIcons(i);
                            sendREST("GET", siteUrl.concat("_api/web/GetFolderByServerRelativeUrl('Shared%20Documents/"+assignedID+"/Study%20Team')"), null, function(returnedFolder){
                                wellSidebarBuilder(targetSection, returnedFolder.d.ItemCount);
                            });

                            //alerting users of exempt question constraints
                            if((currentFormType == "Parent") && (i == 2)){
                                //if a user is submitting an application as an expedited study, then they need to meet the three requirements, which the below logic looks for
                                if(rollupAnswers.contains(study.containedFormCollection[0].containedForm.formQuestionCollection[5].question.answerCollection[1].answersID)){
                                    if(!(rollupAnswers.contains(study.containedFormCollection[2].containedForm.formQuestionCollection[1].question.answerCollection[0].answersID))){
                                        insertWarning("You have selected that your application is expedited, but you haven't checked all three expedited categories", "alert-warning");
                                    }else if(!(rollupAnswers.contains(study.containedFormCollection[2].containedForm.formQuestionCollection[1].question.answerCollection[1].answersID))){
                                        insertWarning("You have selected that your application is expedited, but you haven't checked all three expedited categories", "alert-warning");
                                    }else if(!(rollupAnswers.contains(study.containedFormCollection[2].containedForm.formQuestionCollection[1].question.answerCollection[2].answersID))){
                                        insertWarning("You have selected that your application is expedited, but you haven't checked all three expedited categories", "alert-warning");
                                    }
                                }
                            }
                        }
                    }
                //}
            });
        });
    }
};
